<?php

namespace app\api\controller;

use think\Db;

/**
 * 屏蔽相关
 *
 * Class Block
 * @package app\api\controller
 */
class Block extends Base
{
    /**
     * 屏蔽或取消屏蔽
     *
     * @return string
     */
    public function update()
    {
        $post = $this->_post();
        // 检查必要字段是否为空
        $required = ['block_id', 'value'];
        foreach ($required as $key) {
            if (!isset($post[$key])) {
                return $this->json(1, "缺少参数");
            }
        }

        $uid      = $post['login_uid'];
        $block_id = $post['block_id'];
        $value    = $post['value'];

        // 解除屏蔽
        if ((int)$value === 0) {
            Db::table('block')->where(['uid' => $uid, 'block_id' => $block_id])->delete();
            return $this->json(0);
        }

        // 已经屏蔽
        if (Db::table('block')->where(['uid' => $uid, 'block_id' => $block_id])->find()) {
            return $this->json(0);
        }

        // 解除屏蔽
        Db::table('block')->insert(['uid' => $uid, 'block_id' => $block_id]);

        return $this->json(0);
    }

}
