<?php
namespace app\api\model;

use think\Model;
use think\Db;

/**
 * 个推离线推送相关服务
 */
class Getui extends Model
{

    /**
     * 推送服务构造函数
     *
     */
    public function __construct()
    {
        parent::__construct();
        if (!defined('GETUI_APPID')) {
            $setting = Db::table('setting')->field('getui_appid,getui_appkey,getui_master_secret, getui_api_address')->find();
            define('GETUI_APPID', $setting['getui_appid']);
            define('GETUI_APPKEY', $setting['getui_appkey']);
            define('GETUI_MASTER_SECRET', $setting['getui_master_secret']);
            define('GETUI_API_ADDRESS', $setting['getui_api_address']);
        }
    }


    /**
     * @param $cid
     * @param $title
     * @param $content
     * @param $payload
     */
    /*public function push($cid, $title, $content, $payload=[])
    {
        if (!GETUI_APPKEY) {
            return null;
        }
        $igt = new \IGeTui(GETUI_API_ADDRESS,GETUI_APPKEY,GETUI_MASTER_SECRET);
        $template = $this->IGtTransmissionTemplateDemo($title, $content, $payload);

        $message = new \IGtSingleMessage();

        $message->set_isOffline(true);//是否离线
        $message->set_offlineExpireTime(3600*12*1000);//离线时间
        $message->set_data($template);//设置推送消息类型
        //$message->set_PushNetWorkType(0);//设置是否根据WIFI推送消息，2为4G/3G/2G，1为wifi推送，0为不限制推送
        //接收方
        $target = new \IGtTarget();
        $target->set_appId(GETUI_APPID);
        $target->set_clientId($cid);
        //$target->set_alias(Alias);

        try {
            return $igt->pushMessageToSingle($message, $target);
        }catch(\RequestException $e){
            return (string)$e;
        }
    }
*/
    protected function IGtTransmissionTemplateDemo($title, $content, $payload){
        $template =  new \IGtTransmissionTemplate();
        $template->set_appId(GETUI_APPID);//应用appid
        $template->set_appkey(GETUI_APPKEY);//应用appkey
        $template->set_transmissionType(2);
        $template->set_transmissionContent(json_encode(['title' => $title, 'content' => $content, 'payload' => $payload]));//透传内容

        $apn = new \IGtAPNPayload();
        $alertmsg=new \DictionaryAlertMsg();
        $alertmsg->body=$content;
        $alertmsg->actionLocKey="ActionLockey";
        $alertmsg->locKey="LocKey";
        $alertmsg->locArgs=array("locargs");
        $alertmsg->launchImage="launchimage";
        $alertmsg->subtitleLocArgs = [];
        // IOS8.2 支持
        $alertmsg->title=$title;
        $alertmsg->titleLocKey="TitleLocKey";
        $alertmsg->titleLocArgs=array("TitleLocArg");
        $apn->alertMsg=$alertmsg;
        $apn->autoBadge="+1";
        $apn->sound="";
        $apn->add_customMsg("payload", json_encode($payload));
        // $apn->contentAvailable=1;
        $apn->category="ACTIONABLE";
        $template->set_apnInfo($apn);

        return $template;
    }


    public function push($cid_list, $title, $content, $payload=[])
    {
        if (!GETUI_APPKEY) {
            return null;
        }
        $cid_list = is_array($cid_list) ? $cid_list : [$cid_list];
        $igt = new \IGeTui(GETUI_API_ADDRESS,GETUI_APPKEY,GETUI_MASTER_SECRET);
        $batch = new \IGtBatch(GETUI_APPKEY, $igt);
        $batch->setApiUrl(GETUI_API_ADDRESS);

        $template = $this->IGtTransmissionTemplateDemo($title, $content, $payload);

        $message = new \IGtSingleMessage();

        $message->set_isOffline(true);//是否离线
        $message->set_offlineExpireTime(3600*12*1000);//离线时间
        $message->set_data($template);//设置推送消息类型
        //$message->set_PushNetWorkType(0);//设置是否根据WIFI推送消息，2为4G/3G/2G，1为wifi推送，0为不限制推送
        foreach ($cid_list as $cid) {
            //接收方
            $target = new \IGtTarget();
            $target->set_appId(GETUI_APPID);
            $target->set_clientId($cid);
            //$target->set_alias(Alias);
            $batch->add($message, $target);
        }


        try {
            //return $igt->pushMessageToSingle($message, $target);
            return $batch->submit();
        }catch(\RequestException $e){
            return (string)$e;
        }
    }
}
