<?php
/**
 * Handler File Class
 *
 * @author liliang <liliang@wolive.cc>
 * @email liliang@wolive.cc
 * @date 2017/06/01
 */

namespace app\h5\controller;

use think\Controller;
use think\Db;

/**
 * 基础验证
 */
class Base extends Controller
{
    public function _initialize()
    {
        // 标记是内部调用api接口，让其返回数组，不返回json
        $_GET['internal_call'] = true;
        $_GET['timestamp'] = time();
        $_GET['pop_token'] = md5($_GET['timestamp'] . \think\Config::get('pop.api_secret'));

        // 登录相关的类不需要验证session
        $class = get_class($this);
        if (in_array($class, ['app\h5\controller\Login', 'app\h5\controller\Qrcode'])) {
            return;
        }

        // 检查系统是否执行了安装
        if (!is_file(APP_PATH . '../config/database.php')) {
            return $this->json(-2, '服务端未安装');
        }

        // 开启session
        session_start();
               if (empty($_SESSION['userinfo'])) {
			if (isset($_GET['loginId'])|| isset($_POST['loginId']))
			{
				
				$user = new \app\api\controller\User();
				$user_info = $user->get();
				if($user_info['code'] == 0)
				{
					$_SESSION['userinfo'] = $user_info['data'];
				}
				else{
					return $this->json($user_info['code'], $user_info['msg']);
				}
			}
			else{
				return $this->json(-1, '请登录');
			}
        }
		else
		{
			if (!isset($_GET['loginId']))
			{
				return $this->json(-1, '请登录');
			}
			
			if ($_SESSION['userinfo']['username'] != $_GET['loginId'])
			{
				$user = new \app\api\controller\User();
				$user_info = $user->get();
				if($user_info['code'] == 0)
				{
					$_SESSION['userinfo'] = $user_info['data'];
				}
				else{
					return $this->json($user_info['code'], $user_info['msg']);
				}
			}
		}

        // 默认增加 login_uid 字段，方便api调用
        $_GET['login_uid'] = $_POST['login_uid'] = $_SESSION['userinfo']['uid'];
		$_GET['loginId'] = $_POST['loginId'] = $_SESSION['userinfo']['username'];

        if (in_array($class, [\app\h5\controller\Upload::class]) || $_SERVER['PATH_INFO'] === '/h5/message/send' || $_SERVER['PATH_INFO'] === '/web/message/send') {
            $now = date('d:H:i');
            if (empty($_SESSION['last_update']) || $_SESSION['last_update']['time'] !== $now) {
                $_SESSION['last_update'] = [
                    'time' => $now,
                    'update_count' => 0
                ];
            }
            if ($_SESSION['last_update']['update_count']++ >= 60) {
                if ($_SESSION['last_update']['update_count'] < 300) {
                    return $this->json(1, '发言频率过快');
                }
                Db::table('user')->where('uid', $_SESSION['userinfo']['uid'])->update([
                    'account_state' => 'disabled'
                ]);
                return $this->json(1, '发言频率过快，账号被禁用');
            }
        }

        // 默认增加 login_uid 字段，方便api调用
        $_GET['login_uid'] = $_POST['login_uid'] = $_SESSION['userinfo']['uid'];
    }

    protected function json($code, $msg = '', $data = [])
    {
        header('Content-Type: application/json;charset=utf-8');
        echo json_encode([
            'code' => $code,
            'msg'  => $msg,
            'data' => $data
        ]);
        die;
    }

    protected function jsonArray($data)
    {
        header('Content-Type: application/json;charset=utf-8');
        echo json_encode($data);
        die;
    }
}
