function isInWizApp() {
  // 新版
  if (navigator.userAgent.includes('WizApp')) return true;
  // 旧版
  if (navigator.userAgent.includes('PENGRUIWIZAPP')) return true;
  return false;
}

function loadWizAppUserToken() {
  if (!isInWizApp()) return undefined;
  return new Promise((resolve, reject) => {
    window.wizApp.getToken({
      success: ({ tokenModel }) => {
        resolve(tokenModel);
      },
      fail: (err) => {
        reject(err);
      },
    });
  });
}

async function byWizApp() {
  console.log('[TokenApi] byWizApp');
  const res = await loadWizAppUserToken();
  if (res) {
    const tokenRes = res.access_token;
    localStorage.setItem('DiyToken', tokenRes);
    return tokenRes;
  }
  return undefined;
}

async function getDiyToken() {
  let res = ''
  res = await byWizApp()
  if (!res) {
    // H5访问直接在localStorage设置DiyToken
    res = localStorage.getItem('DiyToken')
  }
  return res
}
