/*
 * @FilePath     : /jssdk/wizjssdk/assets/wizappjssdk.js
 * @Date         : 2022-05-31 10:52:40
 * @Author       : jawa0919 <jawa0919@163.com>
 * @LastEditors  : jawa0919 <jawa0919@163.com>
 * @Description  : wizappjssdk
 */

// v1.1.0 整理文档，修改调试网页
// v1.1.1 add downloadFileSaveInfo
// v1.1.2 fix getToken新增tokenModel
// v1.1.3 add playVideo
// v1.1.4 pref 修改了一些无用的api，补全测试
// v1.1.5 add previewPdf,jumpToHomeTab

(function (w) {
  var fun_prefix = "wiz_fun";
  var bridge_name = "WizAppNativeBridge";
  var _version = "1.1.5";
  var _config = {
    debug: false,
  };
  var _funIds = {};
  var setConfig = function (object) {
    for (var obj in object) {
      _config[obj] = object[obj];
    }
  };
  var exec = (function () {
    var genFunId = (function () {
      var aw = "_0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
      var length = aw.length;
      var m = 5;
      var newFunId = function () {
        var n = Math.floor(m + Math.random() * length);
        var arr = [];
        for (var i = 0; i < n; i++) {
          var x = Math.floor(Math.random() * length);
          arr.push(aw[x]);
        }
        return fun_prefix + arr.join("");
      };
      return function () {
        var funId;
        do {
          funId = newFunId();
        } while (funId in _funIds);
        return funId;
      };
    })();
    return function (funName, funObject) {
      if (_config.debug) console.log("wizappjssdk.start", funName);
      var funId = genFunId();
      _funIds[funId] = function (str) {
        var responseJson = {};
        try {
          responseJson = JSON.parse(str);
        } catch (error) {
          try {
            console.warn("wizappjssdk JSON.parse", error);
            if (_config.debug) console.warn("wizappjssdk callback", str);
            str = str.replace(/\\/g, "\\\\");
            str = str.replace(/\n/g, "\\n");
            str = str.replace(/\r/g, "\\r");
            str = str.replace(/\t/g, "\\t");
            responseJson = JSON.parse(str);
          } catch (error) {
            console.warn("wizappjssdk replace error", error);
            responseJson = { code: 0, error };
          }
        }
        if (_config.debug)
          console.log("wizappjssdk callback", funName, funId, responseJson);
        if (responseJson.code == 0) {
          // 错误0
          if (funObject.fail && typeof funObject.fail == "function") {
            funObject.fail(responseJson.error);
            delete _funIds[funId];
          }
        } else if (responseJson.code == 1) {
          // 成功1
          if (funObject.success && typeof funObject.success == "function") {
            funObject.success(responseJson.data);
            delete _funIds[funId];
          }
        } else if (responseJson.code == 2) {
          // 进度2
          if (funObject.progress && typeof funObject.progress == "function") {
            funObject.progress(responseJson.progress);
          }
        } else {
          console.warn("wizappjssdk unknown code", funName);
        }
      };
      var request = { funName: funName, funId: funId };
      for (var obj in funObject) {
        if (typeof funObject[obj] !== "function") {
          request[obj] = funObject[obj];
        }
      }
      if (_config.debug) console.log("wizappjssdk post", request);
      if (w[bridge_name]) {
        var requestStr = JSON.stringify(request);
        if (/(iPhone|iPad|iPod|iOS)/.test(navigator.userAgent)) {
          w[bridge_name].postMessage(requestStr);
        } else if (/(Android)/.test(navigator.userAgent)) {
          w[bridge_name].postMessage(requestStr);
        } else {
          funObject.fail("unknown os " + w.navigator.userAgent);
          delete _funIds[funId];
        }
      } else {
        if (funObject.fail && typeof funObject.fail == "function") {
          funObject.fail("window." + bridge_name + " is null");
          delete _funIds[funId];
        }
      }
      return funId;
    };
  })();

  var wizApp = {
    /// 函数返回通道
    fn: _funIds,
    /// 配置信息
    setConfig: setConfig,
    /// 调试
    debug: function () {
      // wizApp.debug({});
      setConfig({ debug: true });
    },

    /// 获取token
    getToken: function (cfg) {
      // wizApp.getToken({
      //   success: (res) => {
      //     // interface Res {
      //     //   token?: string;
      //     //   tokenModel?: TokenModel;
      //     // }
      //     // interface TokenModel {
      //     //   accessToken: string;
      //     //   expiresIn: number;
      //     //   refreshToken: string;
      //     //   tokenType: string;
      //     //   profile: Profile;
      //     // }
      //     // interface Profile {
      //     //   sub: string;
      //     //   name: string;
      //     //   givenName: string;
      //     // }
      //     console.log("wizApp.getToken.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.getToken.fail", err);
      //   },
      // });
      exec("getToken", cfg);
    },

    /// 获取用户信息
    getUserInfo: function (cfg) {
      // wizApp.getUserInfo({
      //   success: (res) => {
      //     // interface Res {
      //     //   authTime: number;
      //     //   email: string;
      //     //   headImgUrl: string;
      //     //   orgCode: string;
      //     //   orgId: string;
      //     //   orgName: string;
      //     //   orgType: string;
      //     //   permissions: EASCDic[];
      //     //   roles: EASCDic[];
      //     //   trueName: string;
      //     //   userGroups: EASCDic[];
      //     //   userId: string;
      //     //   userName: string;
      //     // }
      //     // interface EASCDic {
      //     //   id?: string;
      //     //   actionValue: number;
      //     //   name: string;
      //     //   orgTypeId: string;
      //     //   parentId: string;
      //     // }
      //     console.log("wizApp.getUserInfo.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.getUserInfo.fail", err);
      //   },
      // });
      exec("getUserInfo", cfg);
    },

    /// 获取信息
    callUserInfo: function (cfg) {
      // wizApp.callUserInfo({
      //   success: (res) => {
      //     // interface Res {
      //     //   uid: string;
      //     //   nickName: string;
      //     //   trueName: string;
      //     //   email: string;
      //     //   orgName: string;
      //     //   orgId: string;
      //     // }
      //     console.log("wizApp.callUserInfo.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.callUserInfo.fail", err);
      //   },
      // });
      exec("callUserInfo", cfg);
    },

    /// 网络状态
    getNetworkType: function (cfg) {
      // wizApp.getNetworkType({
      //   success: (res) => {
      //     // interface Res {
      //     //   networkType: string;// ["unknown", "none", "mobile", "ethernet", "bluetooth", "wiFi"]
      //     // }
      //     console.log("wizApp.getNetworkType.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.getNetworkType.fail", err);
      //   },
      // });
      exec("getNetworkType", cfg);
    },

    /// 返回上一页
    jsGoBack: function (cfg) {
      // wizApp.jsGoBack({
      //   success: (res) => {
      //     // interface Res {
      //     //   msg: string; // 默认为 success
      //     // }
      //     console.log("wizApp.jsGoBack.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.jsGoBack.fail", err);
      //   },
      // });
      exec("jsGoBack", cfg);
    },

    /// 打开新网页
    openH5Win: function (cfg) {
      // wizApp.openH5Win({
      //   requestUrl: "http.....", // *必填 目标网站地址
      //   success: (res) => {
      //     // interface Res {
      //     //   msg: string; // 默认为 success
      //     // }
      //     console.log("wizApp.openH5Win.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.openH5Win.fail", err);
      //   },
      // });
      exec("openH5Win", cfg);
    },

    /// 关闭Web窗口页面
    closeWin: function (cfg) {
      // wizApp.closeWin({
      //   success: (res) => {
      //     // interface Res {
      //     //   msg: string; // 默认为 success
      //     // }
      //     console.log("wizApp.closeWin.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.closeWin.fail", err);
      //   },
      // });
      exec("closeWin", cfg);
    },

    /// 打开文件
    openFile: function (cfg) {
      // wizApp.openFile({
      //   filePath: "filePath", // (必填) 文件路径
      //   success: (res) => {
      //     // interface Res {
      //     //   msg: string; // 默认为 success
      //     // }
      //     console.log("wizApp.openFile.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.openFile.fail", err);
      //   },
      // });
      exec("openFile", cfg);
    },

    /// 预览PDF
    previewPdf: function (cfg) {
      // wizApp.previewPdf({
      //   url: "url", // (必填) PDF文件路径
      //   success: (res) => {
      //     // interface Res {
      //     //   msg: string; // 默认为 success
      //     // }
      //     console.log("wizApp.previewPdf.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.previewPdf.fail", err);
      //   },
      // });
      exec("previewPdf", cfg);
    },

    /// 设置屏幕方向
    setScreenOrientation: function (cfg) {
      // wizApp.setScreenOrientation({
      //   orientation: "horizontal", // *必填 horizontal横屏 vertical竖屏 auto自动
      //   success: (res) => {
      //     // interface Res {
      //     //   msg: string; // 默认为 success
      //     // }
      //     console.log("wizApp.setScreenOrientation.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.setScreenOrientation.fail", err);
      //   },
      // });
      exec("setScreenOrientation", cfg);
    },

    /// 用户退出登录
    jsLogoutUser: function (cfg) {
      // wizApp.jsLogoutUser({
      //   success: (res) => {
      //     // interface Res {
      //     //   msg: string; // 默认为 success
      //     // }
      //     console.log("wizApp.jsLogoutUser.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.jsLogoutUser.fail", err);
      //   },
      // });
      exec("jsLogoutUser", cfg);
    },

    /// 退出App
    quitApp: function (cfg) {
      // wizApp.quitApp({
      //   success: (res) => {
      //     // interface Res {
      //     //   msg: string; // 默认为 success
      //     // }
      //     console.log("wizApp.quitApp.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.quitApp.fail", err);
      //   },
      // });
      exec("quitApp", cfg);
    },

    /// 扫描二维码
    scanQRCode: function (cfg) {
      // wizApp.scanQRCode({
      //   success: (res) => {
      //     // interface Res {
      //     //   code: string;
      //     // }
      //     console.log("wizApp.scanQRCode.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.scanQRCode.fail", err);
      //   },
      // });
      exec("scanQRCode", cfg);
    },

    /// 存储数据到手机Storage
    setStorageString: function (cfg) {
      // wizApp.setStorageString({
      //   key: "key", // *必填 字段key string类型
      //   value: "value", // *必填 值value any类型
      //   success: (res) => {
      //     // interface Res {
      //     //   msg: string; // 默认为 success
      //     // }
      //     console.log("wizApp.setStorageString.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.setStorageString.fail", err);
      //   },
      // });
      exec("setStorageString", cfg);
    },

    /// 获取Storage存储的key数据
    getStorageString: function (cfg) {
      // wizApp.getStorageString({
      //   key: "key", // *必填 字段key string类型
      //   success: (res) => {
      //     // interface ValueType {
      //     // }
      //     console.log("wizApp.getStorageString.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.getStorageString.fail", err);
      //   },
      // });
      exec("getStorageString", cfg);
    },

    /// 删除Storage存储的key数据
    removeStorageString: function (cfg) {
      // wizApp.removeStorageString({
      //   key: "key", // *必填 字段key string类型
      //   success: (res) => {
      //     // interface Res {
      //     //   msg: string; // 默认为 success
      //     // }
      //     console.log("wizApp.removeStorageString.success", data);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.removeStorageString.fail", error);
      //   },
      // });
      exec("removeStorageString", cfg);
    },

    /// 图片选择器
    chooseImage: function (cfg) {
      // wizApp.chooseImage({
      //   sourceType: ["album"], // *必填 图像来源 album系统图库 camera相机
      //   sizeType: ["compressed"], // *必填 压缩模式 可选字段  original原图 compressed压缩图(同步返回base64数据)
      //   success: (res) => {
      //     // interface Res {
      //     //   path: string;
      //     //   type: string;
      //     //   base64?: string;
      //     // }
      //     console.log("wizApp.chooseImage.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.chooseImage.fail", err);
      //   },
      // });
      exec("chooseImage", cfg);
    },

    /// 视频选择器
    chooseVideo: function (cfg) {
      // wizApp.chooseVideo({
      //   sourceType: ["album"], // *必填 图像来源 album系统图库 camera相机
      //   sizeType: ["compressed"], // *必填 压缩模式 可选字段  original原始 compressed压缩
      //   success: (res) => {
      //     // interface Res {
      //     //   path: string;
      //     //   type: string;
      //     //   thum: thumRes;
      //     // }
      //     // interface thumRes {
      //     //   path: string;
      //     //   type: string;
      //     //   base64?: string;
      //     // }
      //     console.log("wizApp.chooseVideo.success", res);
      //     this.videoRes = res.path;
      //     this.videoResBase64 = res.thum.base64;
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.chooseVideo.fail", err);
      //   },
      // });
      exec("chooseVideo", cfg);
    },

    /// 播放视频
    playVideo: function (cfg) {
      // wizApp.playVideo({
      //   url: "http://xxx", // (必填) 播放地址/文件地址
      //   success: (res) => {
      //     // interface Res {
      //     //   msg: string; // 默认为 success
      //     // }
      //     console.log("wizApp.playVideo.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.playVideo.fail", err);
      //   },
      // });
      exec("playVideo", cfg);
    },

    /// 播放视频
    jumpToHomeTab: function (cfg) {
      // wizApp.jumpToHomeTab({
      //   name: "Contact", // (必填) 跳转的tabId Message/Contact
      //   success: (res) => {
      //     // interface Res {
      //     //   msg: string; // 默认为 success
      //     // }
      //     console.log("wizApp.playVideo.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.playVideo.fail", err);
      //   },
      // });
      exec("jumpToHomeTab", cfg);
    },

    /// 文件选择
    pickFiles: function (cfg) {
      // wizApp.pickFiles({
      //   type: "any", // (选填) 默认any
      //   success: (res) => {
      //     // interface ResItem {
      //     // name: string;
      //     // size: number;
      //     // path: string;
      //     // bytes?: number[];
      //     // }
      //     console.log("wizApp.pickFiles.success", res);
      //     this.fileRes = res[0].path;
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.pickFiles.fail", err);
      //   },
      // });
      exec("pickFiles", cfg);
    },

    // 文件选择并上传
    pickFilesAndUpload: function (cfg) {
      // wizApp.pickFilesAndUpload({
      //   type: "any", // (选填) 默认any，//todo
      //   url: "http://releaseaspnetcore01.wiz.top:9097/resource/submit", // (必填) 请求地址
      //   method: "POST", // (必填) POST GET
      //   data: {}, // (选填) 请求数据
      //   headers: {}, // (选填) 请求头
      //   success: (res) => {
      //     console.log("wizApp.pickFilesAndUpload.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.pickFilesAndUpload.fail", err);
      //   },
      //   progress: (progress) => {
      //     // interface Progress {
      //     //   total: number;
      //     //   count: number;
      //     // }
      //     console.log("wizApp.unZipFile.progress", progress);
      //   },
      // });
      exec("pickFilesAndUpload", cfg);
    },

    /// 获取手机的文件目录
    getRootDirPath: function (cfg) {
      // wizApp.getRootDirPath({
      //   success: (res) => {
      //     // interface Res {
      //     //   path: string;
      //     //   externalPath: string;
      //     //   downloadPath: string;
      //     // }
      //     console.log("wizApp.getRootDirPath.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.getRootDirPath.fail", err);
      //   },
      // });
      exec("getRootDirPath", cfg);
    },

    /// 下载文件
    downloadFile: function (cfg) {
      // wizApp.downloadFile({
      //   url: "http://xx.cn/xxx/xx.apk", // (必填) 下载文件地址
      //   filePath: "/data/path" + "/xxx.apk", //(必填) 目标文件路径
      //   header: {}, // (选填) 请求头
      //   method: "GET", // (选填) 请求默认GET
      //   success: (res) => {
      //     // interface Res {
      //     //   path: string;
      //     // }
      //     console.log("wizApp.downloadFile.success", res);
      //     this.downloadRes = res;
      //     alert(res.path);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.downloadFile.fail", err);
      //   },
      //   progress: (progress) => {
      //     // interface Progress {
      //     //   total: number;
      //     //   count: number;
      //     // }
      //     console.log("wizApp.downloadFile.progress", progress);
      //     this.downloadProgress = progress;
      //   },
      // });
      exec("downloadFile", cfg);
    },

    /// 下载文件保存信息
    downloadFileSaveInfo: function (cfg) {
      // wizApp.downloadFileSaveInfo({
      //   url: "http://xx.cn/xxx/xx.apk", // (必填) 下载文件地址
      //   filePath: "/data/path" + "/xxx.apk", //(必填) 目标文件路径
      //   header: {}, // (选填) 请求头
      //   method: "GET", // (选填) 请求默认GET
      //   success: (res) => {
      //     // interface Res {
      //     //   path: string;
      //     // }
      //     console.log("wizApp.downloadFile.success", res);
      //     this.downloadRes = res;
      //     alert(res.path);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.downloadFile.fail", err);
      //   },
      //   progress: (progress) => {
      //     // interface Progress {
      //     //   total: number;
      //     //   count: number;
      //     // }
      //     console.log("wizApp.downloadFile.progress", progress);
      //     this.downloadProgress = progress;
      //   },
      // });
      exec("downloadFileSaveInfo", cfg);
    },

    /// 解压文件
    unZipFile: function (cfg) {
      // wizApp.unZipFile({
      //   zipFilePath: "/zipFilePath.zip", //(必填) 解压文件路径
      //   zipDirPath: "/zipDirPath/", //(选填) 目标文件夹路径 默认压缩文件的同级目录 eg: /data/talk.zip 则为解压到/data/talk
      //   recursive: true, //(选填) 解压清空文件夹 默认true清空
      //   success: (res) => {
      //     // interface Res {
      //     //   path: string;
      //     // }
      //     console.log("wizApp.unZipFile.success", res);
      //     this.unZipFileRes = res;
      //     alert(res.path);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.unZipFile.fail", err);
      //   },
      //   progress: (progress) => {
      //     console.log("wizApp.unZipFile.progress", progress);
      //     this.unZipFileProgress = progress;
      //   },
      // });
      exec("unZipFile", cfg);
    },

    /// 文件回传
    sendFile: function (cfg) {
      // wizApp.sendFile({
      //   url: "http://xxx", // (必填) 请求地址
      //   method: "POST", // (必填) POST GET
      //   data: {}, // (选填) 请求数据
      //   headers: {}, // (选填) 请求头
      //   sendFilePaths: ["/path/a.txt"], // (选填) 文件地址
      //   success: (res) => {
      //     console.log("wizApp.sendFile.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.sendFile.fail", err);
      //   },
      //   progress: (progress) => {
      //     console.log("wizApp.sendFile.progress", progress);
      //   },
      // });
      exec("sendFile", cfg);
    },

    /// 拨打电话
    makePhoneCall: function (cfg) {
      // wizApp.makePhoneCall({
      //   phoneNumber: "phoneNumber", // (必填) 电话号码
      //   success: (res) => {
      //     // interface Res {
      //     //   msg: string; // 默认为 success
      //     // }
      //     console.log("wizApp.makePhoneCall.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.makePhoneCall.fail", err);
      //   },
      // });
      exec("makePhoneCall", cfg);
    },

    /// 发送短信
    makeSmsCall: function (cfg) {
      // wizApp.makeSmsCall({
      //   phoneNumber: "phoneNumber", // (必填) 电话号码
      //   success: (res) => {
      //     // interface Res {
      //     //   msg: string; // 默认为 success
      //     // }
      //     console.log("wizApp.makeSmsCall.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.makeSmsCall.fail", err);
      //   },
      // });
      exec("makeSmsCall", cfg);
    },

    /// 分享文字
    share: function (cfg) {
      // wizApp.share({
      //   text: "text", // (必填) 文字
      //   subject: "subject", // (选填) 副标题
      //   success: (res) => {
      //     // interface Res {
      //     //   msg: string; // 默认为 success
      //     // }
      //     console.log("wizApp.share.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.share.fail", err);
      //   },
      // });
      exec("share", cfg);
    },

    /// 分享文件
    shareFiles: function (cfg) {
      // wizApp.shareFiles({
      //   paths: ["/path/a.txt"], // (必填) 文件地址
      //   mimeTypes: [], // (选填)
      //   text: "text", // (必填) 文字
      //   subject: "subject", // (选填) 副标题
      //   success: (res) => {
      //     // interface Res {
      //     //   msg: string; // 默认为 success
      //     // }
      //     console.log("wizApp.shareFiles.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.shareFiles.fail", err);
      //   },
      // });
      exec("shareFiles", cfg);
    },

    /// 关闭所有页面，打开到应用内的某个页面
    reLaunch: function (cfg) {
      // wizApp.reLaunch({
      //   url: "/web?url=http://wwww.baidu.com", // (必填) 地址
      //   success: (res) => {
      //     console.log("wizApp.reLaunch.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.reLaunch.fail", err);
      //   },
      // });
      exec("reLaunch", cfg);
    },

    /// 关闭当前页面，跳转到应用内的某个页面
    redirectTo: function (cfg) {
      // wizApp.redirectTo({
      //   url: "/web?url=http://wwww.baidu.com", // (必填) 地址
      //   success: (res) => {
      //     console.log("wizApp.redirectTo.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.redirectTo.fail", err);
      //   },
      // });
      exec("redirectTo", cfg);
    },

    /// 保留当前页面，跳转到应用内的某个页面
    navigateTo: function (cfg) {
      // wizApp.redirectTo({
      //   url: "/web?url=http://wwww.baidu.com", // (必填) 地址
      //   success: (res) => {
      //     console.log("wizApp.redirectTo.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.redirectTo.fail", err);
      //   },
      // });
      exec("navigateTo", cfg);
    },

    /// 状态栏消息，以及状态栏点击事件
    notification: function (cfg) {
      // wizApp.notification({
      //   title: "您有一条短消息", // (必填) 状态栏标题
      //   body: "您需要去往关于页面", // (选填) 状态栏内容
      //   mode: "navigateTo", // (选填) 状态栏点击后事件可选redirectTo/reLaunch/navigateTo不填在无反应
      //   url: "/about", // (选填) 地址与navigateTo系列参数相同
      //   success: (res) => {
      //     console.log("wizApp.notification.success", res);
      //   },
      //   fail: (err) => {
      //     console.log("wizApp.notification.fail", err);
      //   },
      // });
      exec("notification", cfg);
    },
  };
  w.wizApp = wizApp;
})(window);
