$(function () {
    localStorage.setItem('locationSearch', window.location.search)
    var userData = window.location.href.split("?")[1];
    var hasToken = userData.includes('token')
    if (hasToken) {
        var splitToken = getQueryString('token')
        localStorage.setItem('DiyToken', splitToken)
    }
    im = {
        data: {
            chatting: {},
            friend: [],
            secondFriend: [],
            secondFriendList: [],
            group: [],
            mine: [],
            setting: [],
            module: 'chat',
            networkState: '',
            dataLoading: false,
            baseUri: '/im/web/',
            api: {
                baseInfo: '/web/pop/get',                                // 当前用户聚合数据
                deleteChat: '/web/pop/delchat',                          // 删除会话
                userJoin: '/web/login/join',                             // 注册接口
                userDetail: '/web/user/detail',                          // 用户详情
                userUpdate: '/web/user/update',                          // 更新用户接口
                getUserByName: '/web/user/getbyname',                    // 通过登录名获得用户信息接口
                loginCheck: '/web/login/check',                          // 登录接口
                loginCaptcha: '/web/login/logincaptcha',                 // 登录验证码接口
                logout: '/web/login/logout',                             // 退出接口
                joinCaptcha: '/web/login/joincaptcha',                   // 注册验证码
                getSetting: '/web/login/getsetting',                     // 获取配置
                messageSend: '/web/message/send',                        // 发消息接口
                messageRevoke: '/web/message/revoke',                    // 消息撤回接口
                messageGet: '/web/message/get',                          // 获得历史消息接口
                messageUnreadCount: '/web/message/unreadcount',          // 未读消息计数
                updateLastReadTime: '/web/message/updateLastReadTime',   // 更新群组或者好友最后阅读消息时间
                uploadImage: '/web/upload/img',                          // 上传图片接口
                uploadFile: '/web/upload/file',                          // 上传文件接口
                uploadAvatar: '/web/upload/avatar',                      // 上传头像接口
                friendList: '/web/friend/getlist',                       // 好友列表
                friendApply: '/web/friend/apply',                        // 发起好友申请接口
                friendApplyList: '/web/friend/applylist',                // 好友申请列表接口
                friendApplyDetail: '/web/friend/applydetail',            // 好友申请详情接口
                friendApplyCount: '/web/friend/applycount',              // 未读好友申请数
                friendAgree: '/web/friend/agree',                        // 同意好友申请接口
                friendRefuse: '/web/friend/refuse',                      // 拒绝好友申请接口
                friendDelete: '/web/friend/delete',                      // 好友删除接口
                friendRemark: '/web/friend/remark',                      // 备注好友接口
                friendUpdate: '/web/friend/update',                      // 更新好友信息接口
                groupCreate: '/web/group/create',                        // 创建群组接口
                groupDetail: '/web/group/detail',                        // 群组详情
                groupForbiddenUser: '/web/group/forbiddenuser',          // 群组禁用用户接口
                groupForbiddenAll: '/web/group/forbiddenall',            // 群组全员禁言
                groupLeave: '/web/group/leave',                          // 离开群组接口
                groupDelete: '/web/group/delete',                        // 删除或解散群组接口
                groupMemberAdd: '/web/group/memberadd',                  // 群组增加群成员接口
                groupMemberDelete: '/web/group/memberdel',               // 群组删除群成员接口
                groupMembers: '/web/group/members',                      // 获得群成员接口
                groupRemark: '/web/group/remark',                        // 备注群组接口
                groupUpdate: '/web/group/update',                        // 更新群组信息接口
                groupMemberUpdate: '/web/group/memberupdate',            // 更新群成员信息
                authEndpoint: '/web/push/auth'                           // socket通讯验证接口
            },
            chat: function (type, id) {
                im.chat(type, id);
            },
            userDetail: function (uid, gid, search) {
                var detail = search ? user_detail : chat.userDetail;
                detail.uid = uid;
                detail.gid = gid || 0;
                im.ajax({
                    url: im.data.api.userDetail,
                    type: 'get',
                    data: { uid: uid },
                    success: function (res) {
                        if (res.code == 0) {
                            detail.avatar = res.data.avatar;
                            detail.nickname = res.data.nickname;
                            detail.remark = ' ';
                            Vue.nextTick(function () {
                                detail.remark = res.data.remark;
                            });
                            detail.username = res.data.username;
                            detail.isFriend = res.data.is_friend;
                            detail.sign = res.data.sign;
                            detail.accountState = res.data.account_state;
                        }
                    }
                });
                detail.display = Date.parse(new Date());
            },
            groupDetail: function (gid) {
                chat.groupDetail.ended = false;
                chat.groupDetail.gid = gid;
                im.ajax({
                    url: im.data.api.groupDetail,
                    type: 'get',
                    data: { gid: gid },
                    success: function (res) {
                        if (res.code == 0) {
                            chat.groupDetail.members = Object.values(res.data.members);
                            chat.groupDetail.groupname = res.data.info.groupname;
                            chat.groupDetail.remark = res.data.info.remark;
                            chat.groupDetail.uid = res.data.info.uid;
                            if (chat.groupDetail.members.length < 13) {
                                chat.groupDetail.ended = true;
                            }
                        }
                    }
                });
                if (!left_bar.hasSyncAddress) {
                    // im.syncAddress();
                    im.secondSyncAddress();
                    left_bar.hasSyncAddress = true;
                }
                chat.groupDetail.display = Date.parse(new Date());
            }
        },
        isback: false,
        connecter: null,
        promptTone: function () {
            if (im.data.setting.prompt_tone != 'on') return;
            var audio = document.createElement("audio");
            audio.src = '/static/web/sound/default.mp3';
            audio.play();
        },
        connect: function () {
            var wsAddress = im.data.setting.ws_address;
            if (config.socket) {
                wsAddress = config.socket
            }
            im.connecter = new Subscriber({ url: wsAddress });

            // 浏览器监听当前登录者的信息
            var user_channel = im.connecter.subscribe('user-' + im.data.mine.uid);

            // 监听群消息
            $.each(im.data.group, function (k, item) {
                im.listenGroup(item.gid);
            });

            // 监听成功后
            user_channel.on('success', function () {
                if (!im.lastUpdateTime) {
                    im.lastUpdateTime = new Date().getTime();
                    return;
                }
                var now = new Date().getTime();
                // 小于2秒则不更新
                if (now - im.lastUpdateTime < 2000) {
                    return;
                }
                im.syncData();
                im.lastUpdateTime = now;
            });

            // 当前用户接收到消息
            user_channel.on('message', im.onMessage);

            // 当前用户接收到撤回消息
            user_channel.on('revoke', im.revokeMessage);

            // 当前用户接收到加好友申请
            user_channel.on('friendApply', function (data) {
                address_list.syncApplyCount();
                address_list.syncApplyList();
            });

            // 添加了一个好友
            user_channel.on('addFriend', function (data) {
                im.addFriend(data);
            });

            // 当前用户删除了一个好友
            user_channel.on('removeFriend', function (data) {
                im.deleteFriend(data.uid);
            });

            // 创建一个群组
            user_channel.on('addGroup', function (data) {
                im.listenGroup(data.gid);
            });

            user_channel.on('removeGroup', function (data) {
                im.deleteGroup(data.gid);
            });

            var global_channel = im.connecter.subscribe('global');
            global_channel.on('settingChange', function (data) {
                im.data.setting = data;
            });

        },
        ajax: function (options) {
            var success_cb = options.success || false;
            var error_cb = options.error || false;
            var type = (options.type || 'get').toLowerCase();
            var tip = typeof options.tip == 'undefined' ? 2 : options.tip;
            var msg = typeof options.msg == 'undefined' ? 1 : options.msg;
            if (options.url.includes("?")) {
                options.url += "&" + userData;
            } else {
                options.url += "?" + userData;
            }
            if (tip) {
                if (type == 'post') {
                    toast.dataPosting = 1;
                } else {
                    // 操作中
                    im.data.dataLoading = true;
                }
            } else {
                delete options.tip;
            }

            options.success = function (res) {
                if (type == 'post') {
                    if (tip > 1 && res.code == 0) {
                        // 操作成功
                        toast.dataPosting = 2;
                        setTimeout(function () {
                            toast.dataPosting = false;
                        }, 1000);
                    } else {
                        toast.dataPosting = false;
                    }
                } else {
                    im.data.dataLoading = false;
                }
                switch (res.code) {
                    // 需要登录
                    case -1:
                        login.show();
                        return;
                    // 需要cas登录
                    case -3:
                        location = '/cas/login.php';
                        return;
                    // 没有安装
                    case -2:
                        location = '/login.html';
                        actionsheet.msg(res.msg);
                        return;
                }
                if (msg && res.code > 0) {
                    if (res.code == '1') {
                    } else {
                        actionsheet.msg(res.msg);
                    }
                }
                success_cb && success_cb(res);
            };
            options.error = function (error) {
                if (type == 'post') {
                    toast.dataPosting = false;
                } else {
                    im.data.dataLoading = false;
                }
                error_cb && error_cb(error);
            };
            $.ajax(options);
        },
        chat: function (type, id) {
            im.data.module = 'chat';
            chat.reset(chat.id, chat.type);
            chat.id = id;
            chat.type = type;
            im.syncChatting(type, id);
            chat.getmessage(true, null, true);
            chatting.removeBadge(chat.type, chat.id);
        },
        onMessage: function (data) {
            var id = data.type == 'group' || data.from == im.data.mine.uid ? data.to : data.from;
            if (!im.data.chatting[data.type + id]) {
                im.addChatting({
                    id: id,
                    name: id == data.to ? data.to_name : data.from_name,
                    avatar: id == data.to ? data.to_avatar : data.from_avatar,
                    type: data.type,
                    unread_count: 0,
                    items: []
                });
                im.syncUnreadCount(data.type, id);
            }

            var info = data.type == 'group' ? im.getGroupFromLocal(id) : im.getFriendFromLocal(id);
            info = info || {};
            for (var i in im.data.chatting[data.type + id].items) {
                if (data.mid == im.data.chatting[data.type + id].items[i].mid) {
                    return;
                }
            }

            var items = im.data.chatting[data.type + id].items;
            var included = 0;
            for (var j in items) {
                var item = items[j];
                if (data.uniqueId && data.uniqueId == item.uniqueId) {
                    item.mid = data.mid;
                    included = 1;
                    break;
                }
                if (data.mid == item.mid) {
                    included = 1;
                }
            }
            if (!included) {
                im.data.chatting[data.type + id].items.push({
                    mid: data.mid,
                    from: data.from,
                    name: info.remark || data.from_name,
                    to: data.to,
                    avatar: data.from_avatar,
                    content: data.content,
                    timestamp: data.timestamp,
                    sub_type: data.sub_type || 'message'
                });
            }

            chat.scrollBottom(data.from == im.data.mine.uid);

            // 增加红点儿计数
            if (data.from != im.data.mine.uid && (chat.type != data.type || chat.id != id)) {
                if (im.data.chatting[data.type + id].unread_count != '99+') {
                    im.data.chatting[data.type + id].unread_count++;
                    if (im.data.chatting[data.type + id].unread_count >= 100) im.data.chatting[data.type + id].unread_count = '99+';
                }
            } else if (chat.type != data.type && chat.id != id) {
                im.data.chatting[data.type + id].unread_count = 0;
            }
            // 播放提示音
            if (data.from != im.data.mine.uid) {
                im.promptTone();
                im.notify(info.remark || data.from_name || Vue.prototype.$lang('新消息'), {
                    body: im.textContent(data.content),
                    icon: data.from_avatar
                }, function (notification) {
                    //可直接打开通知notification相关联的tab窗口
                    window.focus();
                    notification.close();
                    im.chat(data.type, id);
                    desk_show();
                });
            }
        },
        revokeMessage: function (data) {
            var type = data.type;
            var id = type != 'friend' || data.uid == im.data.mine.uid ? data.id : data.uid;
            var mid = data.mid;
            if (im.data.chatting[type + id]) {
                if (im.data.chatting[type + id].items) {
                    for (var index in im.data.chatting[type + id].items) {
                        var item = im.data.chatting[type + id].items[index];
                        if (item.mid == mid) {
                            im.data.chatting[type + id].items[index].sub_type = 'notice';
                            im.data.chatting[type + id].items[index].content = Vue.prototype.$lang('此消息已撤回');
                            return;
                        }
                    }
                }
            }
        },
        syncChatting: function (type, id) {
            if (!id) {
                console.trace('id undefined');
                return;
            }
            var item = type == 'friend' ? im.getFriendFromLocal(id) : im.getGroupFromLocal(id);
            if (!item) {
                im.addChatting({
                    id: id,
                    type: type
                });
                im.ajax({
                    url: type == 'friend' ? im.data.api.userDetail : im.data.api.groupDetail,
                    type: 'get',
                    data: { uid: id, gid: id, simple: 1 },
                    success: function (res) {
                        if (res.code == 0) {
                            im.addChatting({
                                id: id,
                                name: type == 'friend' ? res.data.remark || res.data.nickname : res.data.remark || res.data.groupname,
                                avatar: res.data.avatar,
                                type: type
                            });
                        }
                    }
                });
            } else {
                item = {
                    id: id,
                    name: item.name,
                    avatar: item.avatar,
                    type: type
                };
                im.addChatting(item);
                return item;
            }
        },
        addChatting: function (data) {
            // 更新数据库为chatting状态
            if (!im.data.chatting[data.type + data.id]) {
                Vue.set(im.data.chatting, data.type + data.id, {
                    id: data.id,
                    name: data.name,
                    avatar: data.avatar,
                    type: data.type,
                    unread_count: data.unread_count || 0,
                    items: data.items || []
                });
            } else {
                $.each(im.data.chatting[data.type + data.id], function (k, v) {
                    if (typeof data[k] != 'undefined') {
                        im.data.chatting[data.type + data.id][k] = data[k];
                    }
                });
            }
        },
        syncLang: function () {
            Vue.set(im.data, 'language', localStorage.getItem('language') || 'zh-CN');
            im.ajax({
                url: '/lang.json',
                type: 'get',
                success: function (res) {
                    console.log(res);
                    Vue.set(im.data, 'lang', res);
                    console.log(im.data);
                }
            });
        },
        deleteChatting: function (type, id) {
            if (im.data.chatting[type + id]) {
                Vue.delete(im.data.chatting, type + id);
            }
            if (chat.id == id && chat.type == type) {
                chat.id = 0;
            }
        },
        syncSetting: function () {
            im.ajax({
                url: im.data.api.getSetting,
                success: function (res) {
                    if (res.code == 0) {
                        im.data.setting = res.data;
                        document.title = res.data.app_name;
                    }
                }
            });
        },
        syncUnreadCount: function (type, id) {
            im.ajax({
                url: im.data.api.messageUnreadCount,
                type: 'get',
                data: { type: type, id: id },
                success: function (res) {
                    if (res.code == 0) {
                        if (im.data.chatting[type + id]) {
                            im.data.chatting[type + id]['unread_count'] = res.data;
                        }
                    }
                }
            });
        },
        syncUser: function (uid) {
            im.ajax({
                url: im.data.api.userDetail,
                type: 'get',
                data: { uid: uid },
                success: function (res) {
                    if (res.code == 0) {
                        $.each(im.data.friend, function (char, items) {
                            if (items[uid]) {
                                im.data.friend[char][uid].name = res.data.remark || res.data.nickname;
                                im.data.friend[char][uid].avatar = res.data.avatar;
                            }
                        });
                        if (im.data.chatting['friend' + uid]) {
                            im.data.chatting['friend' + uid].avatar = res.data.avatar;
                            im.data.chatting['friend' + uid].name = res.data.remark || res.data.nickname;
                        }
                    }
                }
            });
        },
        syncGroup: function (gid) {
            im.ajax({
                url: im.data.api.groupDetail,
                type: 'get',
                data: { gid: gid, simple: 1 },
                success: function (res) {
                    if (res.code == 0) {
                        var in_group = false;
                        $.each(im.data.group, function (index, item) {
                            if (item.gid == gid) {
                                im.data.group[index].name = res.data.remark || res.data.groupname;
                                im.data.group[index].avatar = res.data.avatar;
                                im.data.group[index].uid = res.data.uid;
                                in_group = true;
                            }
                        });
                        if (!in_group) {
                            im.data.group.push({
                                gid: gid,
                                avatar: res.data.avatar,
                                name: res.data.remark || res.data.groupname,
                                uid: res.data.uid
                            });
                        }
                        if (im.data.chatting['group' + gid]) {
                            im.data.chatting['group' + gid].avatar = res.data.avatar;
                            im.data.chatting['group' + gid].name = res.data.remark || res.data.groupname;
                        }
                    }
                }
            });
        },
        syncData: function () {
            im.ajax({
                url: im.data.api.baseInfo,
                type: 'get',
                success: function (res) {
                    switch (res.code) {
                        // 获取用户信息成功
                        case 0:
                            im.data.mine = res.data.mine;
                            $.each(res.data.chatting, function (key, chatting_item) {
                                var items = im.data.chatting[key] ? im.data.chatting[key].items : [];
                                Vue.set(im.data.chatting, key, chatting_item);
                                if (!items.length || !chatting_item.items.length) {
                                    return;
                                }
                                var max_mid = chatting_item.items[0].mid;
                                if (max_mid > items[items.length - 1]['mid']) {
                                    items.push(chatting_item.items[0]);
                                }
                                im.data.chatting[key].items = items;
                            });
                            chat.getmessage(true, null, true);
                            //im.data.friend = res.data.friend;
                            if (this.im.module = 'addressBook') {
                                // im.syncAddress();
                                im.secondSyncAddress();
                                left_bar.hasSyncAddress = true;
                            } else {
                                left_bar.hasSyncAddress = false;
                            }

                            im.data.group = res.data.group;
                            im.data.setting = res.data.setting;
                            if (!im.connectionInited) {
                                im.connectionInited = true;
                                im.connect();
                            }
                            address_list.unreadApplyCount = res.data.mine.unread_friend_apply_count;
                            $('#main_page').css('display', 'block');
                            // login.display = false;
                            return;
                        case 101:
                            // 用户不存在，走转登录
                            login.show();
                            return;
                    }
                }
            });
        },
        syncApplyCount: function () {
            var that = this;
            im.ajax({
                url: im.data.api.friendApplyCount,
                type: 'get',
                success: function (res) {
                    if (res.code == 0) {
                        address_list.unreadApplyCount = res.data;
                    }
                }
            });
        },
        addFriend: function (data) {
            im.addChatting({
                id: data.uid,
                name: data.name,
                avatar: data.avatar,
                type: 'friend',
                key: 'friend' + data.uid,
                unread_count: 0,
                items: []
            });
            // im.syncAddress();
            im.secondSyncAddress();
        },
        updateGroup: function (gid, data) {
            if (im.data.chatting['group' + gid]) {
                for (var k in data) {
                    if (typeof im.data.chatting['group' + gid][k] != 'undefined') {
                        Vue.set(im.data.chatting['group' + gid], k, data[k]);
                    }
                }
            }
        },
        updateFriend: function (uid, data) {
            if (im.data.chatting['friend' + uid]) {
                for (var k in data) {
                    if (typeof im.data.chatting['friend' + uid][k] != 'undefined') {
                        Vue.set(im.data.chatting['friend' + uid], k, data[k]);
                    }
                }
            }
            // im.syncAddress();
            im.secondSyncAddress();
        },
        deleteFriend: function (uid) {
            im.deleteChatting('friend', uid);
            im.deleteFriendFromLocal(uid);
        },
        deleteGroup: function (gid) {
            im.unlistenGroup(gid);
            im.deleteChatting('group', gid);
            im.deleteGroupFromLocal(gid);
        },
        syncAddress: function () {
            im.ajax({
                url: im.data.api.friendList,
                type: 'get',
                success: function (res) {
                    if (res.code == 0) {
                        Vue.set(im.data, 'friend', res.data);
                        if (im.data.secondFriendList.length) {
                            let handleArr = []
                            Object.keys(im.data.friend).map(it =>{ return im.data.friend[it]}).map(item => {
                                handleArr = [...handleArr, ...Object.values(item)] 
                                return item
                            })
                            const arr = im.addUID(im.data.secondFriendList, handleArr)
                            Vue.set(im.data, 'secondFriend', arr);
                        }
                    }
                }
            });
        },
        // 添加uid
        addUID:function (treeList, list) {
            treeList.forEach((item) => {
                if (item.account) {
                    const currData = list.find(it => it.username === item.account)
                    if (currData) {
                        item.uid = currData.uid
                    }
                }
                if (item.children) {
                    im.addUID(item.children, list)
                }
            })
            return treeList
        },
        // 二开获取部门人员数据
        secondSyncAddress: function () {
            const token = `Bearer ${localStorage.getItem('DiyToken')}`
            im.ajax({
                url: `${config.VUE_APP_SECOND_SERVER}/api/alarm-level-management/get-user-tree`,
                type: 'get',
                headers: {
                    Authorization: token
                },
                success:async function (res) {
                    if (res.code == '1') {
                        await im.syncAddress()
                        if (im.data.friend.length) {
                            let handleArr = []
                            Object.keys(im.data.friend).map(it =>{ return im.data.friend[it]}).map(item => {
                                handleArr = [...handleArr, ...Object.values(item)] 
                                return item
                            })
                            const arr = im.addUID(res.data, handleArr)
                            Vue.set(im.data, 'secondFriend', arr);
                        } else {
                            Vue.set(im.data, 'secondFriendList', res.data);
                        }
                    }
                }
            });
        },
        getFriendFromLocal: function (uid) {
            for (var char in im.data.friend) {
                var items = im.data.friend[char];
                if (items[uid]) return items[uid];
            }
        },
        deleteFriendFromLocal: function (uid) {
            for (var char in im.data.friend) {
                var items = im.data.friend[char];
                if (items[uid]) {
                    Vue.delete(im.data.friend[char], uid);
                    if (!Object.values(im.data.friend[char]).length) {
                        Vue.delete(im.data.friend, char);
                    }
                    return;
                }
            }
        },
        getGroupFromLocal: function (gid) {
            for (var key in im.data.group) {
                if (im.data.group[key].gid == gid) return im.data.group[key];
            }
        },
        deleteGroupFromLocal: function (gid) {
            for (var key in im.data.group) {
                if (im.data.group[key].gid == gid) {
                    Vue.delete(im.data.group, key);
                    return;
                }
            }
        },
        listenGroup: function (gid) {
            var key = 'group-' + gid;
            if (im.connecter.channels[key]) {
                return;
            }
            var group_channel = im.connecter.subscribe(key);
            group_channel.on('message', im.onMessage);
            group_channel.on('updateGroup', function (data) {
                var gid = data.gid;
                im.updateGroup(gid, data);
            });
            group_channel.on('removeGroup', function (data) {
                im.deleteGroup(data.gid);
            });
            group_channel.on('update', function (data) {
                im.updateGroup(gid, data);
            });
            group_channel.on('revoke', im.revokeMessage);
        },
        unlistenGroup: function (gid) {
            im.connecter.unsubscribe('group-' + gid);
        },
        check: function (ctx) { // 如果设置了backToPath，则一直后退到backToPath地址
            if (im.backToPath) {
                if (im.backToPath != ctx.path) {
                    console.log('backToPath:' + im.backToPath);
                    history.back();
                    return false;
                }
                im.backToPath = '';
            }
            im.context = ctx;
            return true;
        },
        setting: function (title, desc, content, btn_name, callback) {
            setting.title = title;
            setting.desc = desc;
            setting.btn_name = btn_name;
            setting.content = im.htmlDecode(content);
            setting.callback = callback ? callback : null;
            setting.display = true;
        },
        autoUpdateTime: function () {
            $.each($('.pop__time'), function (key, item) {
                var $item = $(item);
                $item.html(Vue.prototype.$formatTime(($item.attr('value'))));
            });
        },
        checkUsername: function (name) {
            var reg = /^[A-Za-z0-9]{1,60}$/;
            return reg.test(name);
        },
        isDangerousUrl: function (url) {
            url = url.toLowerCase();
            // url不允许有javascript关键字
            if (url.indexOf('javascript') != -1) return true;
            // url里必须以/或http或https开头
            if (url.indexOf('/') != 0 && url.indexOf('http') != 0 && url.indexOf('http') != 0) return true;
            return false;
        },
        textContent: function (content) {
            content = content.replace(/\[表情\d+\]/g, '[表情]');
            // 图片
            if (/\!\[.*?\]\(([^\)]+?)\)/.test(content)) {
                content = '[' + Vue.prototype.$lang('图片') + ']';
            } else if (/^voice\[\d+\]\(([^\)]+?)\)$/.test(content)) {
                content = '[' + Vue.prototype.$lang('语音') + ']';
            } else if (/^voice\(([^\)]+?)\)$/.test(content)) {
                content = '[' + Vue.prototype.$lang('语音') + ']';
            } else if (/^file\[(.*?)[\t|\|](.*?)]\((.+?)\)$/.test(content)) {
                content = '[' + Vue.prototype.$lang('文件') + ']';
            } else if (/\[.*?\]\(([^\)]+?)\)/.test(content)) {
                // 替换a连接
                content = content.replace(/\[(.*?)\]\(([^\)]+?)\)/g, '$1');
            }
            return content;
        },
        htmlEncode: function (html) {
            var map =
            {
                '&': '&amp;',
                '<': '&lt;',
                '>': '&gt;',
                '"': '&quot;',
                "'": '&#039;'
            };
            return html.replace(/[&<>"']/g, function (m) {
                return map[m];
            });
        },
        htmlDecode: function (text) {
            var map =
            {
                '&amp;': '&',
                '&lt;': '<',
                '&gt;': '>',
                '&quot;': '"',
                '&#039;': "'"
            };
            return text.replace(/&amp;|&lt;|&gt;|&quot;|&#039;/g, function (m) {
                return map[m];
            });
        },
        stripTags: function (str, allow) {
            allow = (((allow || '') + '').toLowerCase().match(/<[a-z][a-z0-9]*>/g) || []).join('');

            var tags = /<\/?([a-z][a-z0-9]*)\b[^>]*>/gi;
            var commentsAndPhpTags = /<!--[\s\S]*?-->|<\?(?:php)?[\s\S]*?\?>/gi;
            return str.replace(commentsAndPhpTags, '').replace(tags, function ($0, $1) {
                return allow.indexOf('<' + $1.toLowerCase() + '>') > -1 ? $0 : '';
            });
        },
        scrollIntoView: function (letter) {
            var char = letter;
            letter = letter == '#' ? 'other' : letter;
            $.each($('.pop__firend_list_' + letter), function (k, item) {
                item.scrollIntoView();
            });

            $(".pop__friend-list-showletter").text(char).fadeIn(300);
            setTimeout(function () {
                $(".pop__friend-list-showletter").fadeOut(300);
            }, 500);
        },
        notify: function (title, options, callback) {
            // 先检查浏览器是否支持
            if (!window.Notification || document.visibilityState != 'hidden') {
                return;
            }
            var notification;
            // 检查用户曾经是否同意接受通知
            if (Notification.permission === 'granted') {
                notification = new Notification(title, options); // 显示通知

            } else if (Notification.permission === 'default') {
                var promise = Notification.requestPermission();
            }

            if (notification && callback) {
                notification.onclick = function (event) {
                    callback(notification, event);
                }
            }
        }
    };

    // input编辑组件
    Vue.component('input-editor', {
        props: ['content', 'url', 'index', 'params', 'callback'],
        computed: {
            htmlContent: function () {
                return im.htmlDecode(this.content);
            }
        },
        methods: {
            select: function () {
                this.oldValue = this.$refs.input.value;
                this.$refs.input.select();
            },
            post: function () {
                var new_value = this.$refs.input.value;
                if (this.oldValue == new_value) {
                    return;
                }
                var data = this.params;
                data[this.index] = new_value;
                var that = this;
                im.ajax({
                    url: this.url,
                    type: 'post',
                    data: data,
                    success: function (res) {
                        that.callback && that.callback.call(this, new_value, res);
                    }
                });
                this.oldValue = new_value;
            },
            blur: function () {
                this.$refs.input.blur();
            }
        },
        template: '<input class="pop__detail-section pop__input" type="text" :value="htmlContent" @focus="select" @blur="post" @keyup.13="blur" ref="input">'
    });

    // 登录
    // var login = new Vue({
    //     el: '#login',
    //     data: {
    //         im: im.data,
    //         username: '',
    //         password: '',
    //         captcha: '',
    //         display: true
    //     },
    //     methods: {
    //         show: function () {
    //             this.display = true;
    //             $('#main_page').css('display', 'none');
    //             im.syncSetting();
    //             this.switchCaptcha();
    //         },
    //         login: function () {
    //             if (this.username == '') {
    //                 return actionsheet.msg(Vue.prototype.$lang('用户名不能为空'));
    //             } else if (this.password == '') {
    //                 return actionsheet.msg(Vue.prototype.$lang('密码不能为空'));
    //             } else if (this.captcha == '') {
    //                 return actionsheet.msg(Vue.prototype.$lang('验证码不能为空'));
    //             } else {
    //                 var that = this;
    //                 $.ajax({
    //                     url: im.data.api.loginCheck,
    //                     type: 'post',
    //                     tip: 0,
    //                     data: { username: this.username, password: this.password, captcha: this.captcha },
    //                     success: function (res) {
    //                         if (res.code == 0) {
    //                             login.display = false;
    //                             im.syncData();
    //                         } else {
    //                             that.switchCaptcha();
    //                             actionsheet.msg(res.msg);
    //                         }
    //                     }
    //                 });
    //             }
    //         },
    //         switchCaptcha: function () {
    //             this.$refs.captchaImg.src = im.data.api.loginCaptcha + '?rand=' + Math.random();
    //         },
    //         switchToJoin: function () {
    //             $('#main_page').css('display', 'none');
    //             this.display = false;
    //             join.show();
    //         },
    //         switchLang: function () {
    //             language.show();
    //         }
    //     }
    // });

    // 注册
    var join = new Vue({
        el: '#join',
        data: {
            im: im.data,
            username: '',
            nickname: '',
            password: '',
            sign: '',
            captcha: '',
            display: false
        },
        methods: {
            show: function () {
                this.display = true;
                this.switchCaptcha();
            },
            join: function () {
                if (this.username == '') {
                    return actionsheet.msg(Vue.prototype.$lang('用户名不能为空'));
                } else if (this.nickname == '') {
                    return actionsheet.msg(Vue.prototype.$lang('昵称不能为空'));
                } else if (this.password == '') {
                    return actionsheet.msg(Vue.prototype.$lang('密码不能为空'));
                } else if (this.captcha == '') {
                    return actionsheet.msg(Vue.prototype.$lang('验证码不能为空'));
                } else {
                    if (!im.checkUsername(this.username)) {
                        return actionsheet.msg(Vue.prototype.$lang('用户名只能包含字母和数字，长度小于60'));
                    }
                    var that = this;
                    im.ajax({
                        url: im.data.api.userJoin,
                        type: 'post',
                        tip: 0,
                        data: {
                            username: this.username,
                            password: this.password,
                            nickname: this.nickname,
                            sign: this.sign,
                            captcha: this.captcha
                        },
                        success: function (res) {
                            if (res.code == 0) {
                                that.switchToLogin();
                                return;
                            } else {
                                that.switchCaptcha();
                                actionsheet.msg(res.msg);
                            }
                        }
                    });
                }
            },
            switchCaptcha: function () {
                this.$refs.captchaImg.src = im.data.api.joinCaptcha + '?rand=' + Math.random();
            },
            switchToLogin: function () {
                this.display = false;
                // login.show();
            },
            switchLang: function () {
                language.show();
            }
        }
    });

    var home = new Vue({
        el: '#home',
        mounted: function () {
            im.syncData();
            im.syncLang();
        }
    });

    var address_list = new Vue({
        el: '#address_list',
        data: {
            im: im.data,
            panel: 'friend', // friend group apply
            selectedUid: 0,
            selectedGid: 0,
            selectedNid: 0,
            unreadApplyCount: 0,
            applyList: [],
            defaultProps: {
                children: 'children',
                label: 'name',
            },
        },
        computed: {
            userDisplay: function () {
                return chat.userDetail.display;
            },
            groupDisplay: function () {
                return chat.groupDetail.display;
            },
            applyDisplay: function () {
                return chat.applyDetail.display;
            }
        },
        methods: {
            // tree点击事件
            nodeClick(event){
                console.log(event,'event');
                if (event.uid) {
                    this.friendDetail(event.uid)
                } else {
                    chat.userDetail.display = false
                }
            },
            // 双击事件
            doubleClick(uid) {
                if (uid) {
                    im.chat('friend', uid)
                }
            },
            // tree搜索
            filterNode(value, data) {
                if (!value) return true;
                return data.label.indexOf(value) !== -1;
            },
            friendDetail: function (uid) {
                this.selectedUid = uid;
                this.im.userDetail(uid);
            },
            groupDetail: function (gid) {
                group.display = false;
                this.selectedGid = gid;
                this.im.groupDetail(gid);
            },
            createGroup: function () {
                this.selectedGid = -1;
                group.create();
            },
            showApplyList: function () {
                this.syncApplyList();
                this.panel = 'apply';
            },
            syncApplyList: function () {
                var that = this;
                im.ajax({
                    url: im.data.api.friendApplyList,
                    type: 'get',
                    success: function (res) {
                        if (res.code == 0) {
                            that.applyList = res.data;
                        }
                    }
                });
            },
            applyDetail: function (nid) {
                this.selectedNid = nid;
                chat.applyDetail.username = chat.applyDetail.nickname = chat.applyDetail.avatar = chat.applyDetail.postScript = chat.applyDetail.operation = '';
                chat.applyDetail.nid = nid;
                im.ajax({
                    url: im.data.api.friendApplyDetail,
                    type: 'get',
                    data: { nid: nid },
                    success: function (res) {
                        if (res.code == 0) {
                            chat.applyDetail.avatar = res.data.avatar;
                            chat.applyDetail.nickname = res.data.nickname;
                            chat.applyDetail.username = res.data.username;
                            var apply_data = res.data.data ? JSON.parse(res.data.data) : {};
                            chat.applyDetail.postScript = apply_data.postscript || '';
                            chat.applyDetail.operation = res.data.operation;
                        }
                    }
                });
                chat.applyDetail.display = Date.parse(new Date());
            },
            operationName: function (operation) {
                if (operation == 'not_operated') {
                    return '<button href="javascript:;" class="pop__btn-primary-mini">' + this.$lang('查看') + '</button>';
                } else if (operation == 'agree') {
                    return '<label>' + this.$lang('已同意') + '</label>';
                } else if (operation == 'refuse') {
                    return '<label>' + this.$lang('已拒绝') + '</label>';
                }
                return operation;
            },
            applyAgree: function (nid) {
                var that = this;
                im.ajax({
                    url: im.data.api.friendAgree,
                    type: 'post',
                    data: { nid: nid },
                    success: function (res) {
                        if (res.code == 0) {
                            that.syncApplyCount();
                            // im.syncAddress();
                            im.secondSyncAddress();
                            that.syncApplyList();
                            chat.applyDetail.operation = 'agree';
                        }
                    }
                });
            },
            applyRefuse: function (nid) {
                var that = this;
                im.ajax({
                    url: im.data.api.friendRefuse,
                    type: 'post',
                    data: { nid: nid },
                    success: function (res) {
                        if (res.code == 0) {
                            that.syncApplyCount();
                            chat.applyDetail.operation = 'refuse';
                            that.syncApplyList();
                        }
                    }
                });
            },
            syncApplyCount: function () {
                im.ajax({
                    url: im.data.api.friendApplyCount,
                    type: 'get',
                    success: function (res) {
                        if (res.code == 0) {
                            address_list.unreadApplyCount = res.data;
                        }
                    }
                });
            }
        }
    });

    var left_bar = new Vue({
        el: '#left-bar',
        data: {
            im: im.data,
            subMenuDisplay: false
        },
        computed: {
            unreadMessageCount: function () {
                var count = 0;
                $.each(im.data.chatting, function (k, item) {
                    if (count == '99+') return;
                    if (item.unread_count == '99+') {
                        count = '99+';
                        return;
                    }
                    count += item.unread_count;
                });
                return count;
            },
            applyCount: function () {
                return address_list.unreadApplyCount;
            }
        },
        methods: {
            switchToAddressBook: function () {
                this.im.module = 'addressBook';
                // 同步im.friend
                if (!this.hasSyncAddress) {
                    // im.syncAddress();
                    im.secondSyncAddress();
                    this.hasSyncAddress = true;
                }
            },
            switchLang: function () {
                language.show();
            },
            logout: function () {
                im.ajax({
                    url: im.data.api.logout,
                    type: 'POST',
                    data: { logout_uid: im.data.mine.uid },
                    tip: 0,
                    success: function (res) {
                        location.reload();
                        return;
                    }
                });
            }
        }
    });

    var chatting = new Vue({
        el: '#chatting',
        data: {
            im: im.data,
            contextmenuType: 'friend',
            contextmenuId: 0,
            contextmenuTop: 0,
            contextmenuLeft: 0,
        },
        computed: {
            chattingItems: function () {
                return Object.values(this.im.chatting).sort(function (a, b) {
                    var item_a = a.items.length && a.items.slice(-1)[0];
                    var item_b = b.items.length && b.items.slice(-1)[0];
                    var time_a = item_a && item_a.timestamp ? item_a.timestamp : 0;
                    var time_b = item_b && item_b.timestamp ? item_b.timestamp : 0;
                    return ((time_a > time_b) ? -1 : (time_a < time_b) ? 1 : 0)
                });
            },
            selectedItem: function () {
                return chat.chattingInfo;
            }
        },
        methods: {
            lastMessage: function (item) {
                item = item.items.length && item.items.slice(-1)[0];
                if (!item) {
                    return {
                        content: '',
                        timestamp: 0
                    };
                }
                return {
                    content: im.textContent(item['content']),
                    timestamp: item['timestamp']
                };
            },
            removeBadge: function (type, id) {
                if (im.data.chatting[type + id]) {
                    im.data.chatting[type + id].unread_count = 0;
                }
            },
            contextmenu: function (type, id, event) {
                this.contextmenuType = type;
                this.contextmenuId = id;
                this.contextmenuTop = event.clientY;
                this.contextmenuLeft = event.clientX + 5;
            },
            deleteItem: function (type, id) {
                if (!id) {
                    return;
                }
                im.ajax({
                    url: im.data.api.deleteChat,
                    type: 'post',
                    data: { type: type, id: id },
                    success: function (res) {
                        if (res.code == 0) {
                            im.deleteChatting(type, id);
                        }
                    }
                });
            },
        }
    });

    chat = new Vue({
        el: '#chat',
        data: {
            im: im.data,
            type: '',
            id: 0,
            messageLock: false,
            messageEnd: false,
            message: '',
            panel: '',
            tapMenuShow: false,
            supportRevoke: false,
            supportMemberDelete: false,
            supportForbidden: false,
            tapedMid: 0,
            voiceRecording: false,
            files: [],
            userDetail: {
                display: false,
                remark: '',
                username: '',
                nickname: '',
                sign: '',
                avatar: '',
                isFriend: false,
                uid: 0,
                gid: 0,
                accountState: 'normal'
            },
            groupDetail: {
                display: false,
                gid: 0,
                uid: 0,
                groupname: '',
                remark: '',
                forbid_speaking: 0,
                members: [],
                index: 0,
                ended: false
            },
            applyDetail: {
                nid: 0,
                nickname: '',
                username: '',
                avatar: '',
                postScript: '',
                operation: '',
                display: false
            }
        },
        components: {
            FileUpload: VueUploadComponent
        },
        computed: {
            supportUserDetail: function () {
                if (this.im.setting.member_detail == 'off' && !this.isGroupOwner) {
                    return false;
                }
                return true;
            },
            chattingInfo: function () {
                return im.data.chatting[this.type + this.id] || {};
            },
            messageList: function () {
                this.lastInsertTime = this.lastTime = 0;
                if (!this.im.chatting[this.type + this.id]) {
                    return [];
                }
                return this.im.chatting[this.type + this.id]['items'] || [];
            },
            mid: function () {
                var messageList = this.im.chatting[this.type + this.id];
                if (!messageList || !messageList.items || !messageList.items.length) {
                    return null;
                }
                return messageList.items[0]['mid'] || null;
            },
            supportCopy: function () {
                return typeof document.execCommand == 'function';
            },
            isGroupOwner: function () {
                if (this.type != 'group') return false;
                var group_info = im.getGroupFromLocal(this.id);
                return group_info && group_info.uid == im.data.mine.uid
            }
        },
        methods: {
            reset: function (id, type) {
                this.userDetail.display = false;
                this.groupDetail.display = false;
                if (!id) return;
                // 更新最后阅读时间
                im.ajax({
                    url: im.data.api.updateLastReadTime,
                    type: 'post',
                    tip: 0,
                    data: {
                        id: id,
                        type: type
                    }
                });
                if (this.im.chatting[type + id] && this.im.chatting[type + id]['items']) {
                    this.im.chatting[type + id].items = this.im.chatting[type + id].items.slice(-20);
                    this.im.chatting[type + id].unread_count = 0;
                }
                this.voiceTips = this.message = '';
                this.messageEnd = this.messageLock = this.panel = this.voice = false;
                this.voiceBtnTips = this.$lang('按住 说话');
                this.lastTime = this.lastInsertTime = 0;
            },
            emojiList: function () {
                var emoji_list = [
                    ['😀', '😄', '😆', '😂', '😇', '😉', '😊', '🙂', '😋', '😌', '😍', '😘', '😗', '😝', '🤑', '😎', '🤓', '🤗', '😶', '😑', '🙄'],
                    ['🤔', '😳', '😡', '🙁', '😬', '😣', '😩', '😤', '😱', '😰', '😢', '😓', '😭', '😵', '🤐', '😷', '😴', '💤', '😈', '💩', '👻'],
                    ['💀', '🤖', '🎃', '😹', '🙀', '👏', '🙏', '👍', '👎', '👊', '✊', '👌', '👉', '👈', '👆', '👇', '💪', '⚽', '🏀', '🎂', '🍎'],
                    ['🐶', '🐮', '🍔', '🎉', '🎁', '💊', '🔑', '⏱', '💰', '💍', '🚀', '🚘', '🚲', '🖥 ']
                ];
                return emoji_list;
            },
            needInsertTime: function (timestamp) {
                if (timestamp < this.lastTime) {
                    this.lastInsertTime = 0;
                }
                this.lastTime = timestamp;
                if (new Date().getTime() > timestamp && timestamp - this.lastInsertTime > 60) {
                    this.lastInsertTime = timestamp;
                    return true;
                }
                return false;
            },
            send: function () {
                if (this.message == '') {
                    return;
                }
                chat.doSend(this.message);
                this.message = '';
            },
            doSend: function (message) {
                var uniqueId = new Date().getTime();
                im.ajax({
                    url: im.data.api.messageSend,
                    type: 'post',
                    tip: 0,
                    data: {
                        to: this.id,
                        content: message,
                        type: this.type,
                        uniqueId: uniqueId
                    },
                    success: function (res) {

                    },
                    error: function () {
                        actionsheet.msg(this.$lang('发送失败，网络/服务器不可用'));
                    }
                });
                var chatting = this.im.chatting;
                chatting[this.type + this.id].items.push({
                    mid: -uniqueId,
                    from: this.im.mine.uid,
                    to: this.id,
                    avatar: this.im.mine.avatar,
                    content: message,
                    timestamp: parseInt(uniqueId / 1000),
                    sub_type: 'message',
                    uniqueId: uniqueId,
                    name: this.im.mine.nickname
                });
                this.scrollBottom(1);
            },
            readImageAndSend: function (item) {
                var blob = item.getAsFile();
                var formData = new FormData();
                formData.append('file', blob);
                im.ajax({
                    url: im.data.api.uploadImage,
                    type: 'POST',
                    data: formData,
                    //这两个设置项必填
                    contentType: false,
                    processData: false,
                    tip: 1,
                    success: function (res) {
                        if (res.code == 0) {
                            var content = '![图片](' + res.data.src + ')';
                            chat.doSend(content);
                        }
                    }
                });
            },
            paste: function (e) {
                console.log('paste');
                // 添加到事件对象中的访问系统剪贴板的接口
                var clipboardData = e.clipboardData,
                    i = 0,
                    items, item, types;

                if (clipboardData) {
                    items = clipboardData.items;
                    if (!items) {
                        return;
                    }
                    item = items[0];
                    // 保存在剪贴板中的数据类型
                    types = clipboardData.types || [];
                    for (; i < types.length; i++) {
                        if (types[i] === 'Files') {
                            item = items[i];
                            break;
                        }
                    }
                    // 判断是否为图片数据
                    if (item && item.kind === 'file' && item.type.match(/^image\//i)) {
                        this.readImageAndSend(item);
                    }
                }
            },
            toggleVoice: function () {
                this.voice = !this.voice;
            },
            openEmotion: function () {
                if (this.panel == 'face') {
                    this.panel = false;
                    return;
                }
                this.panel = 'face';
            },
            openFunction: function () {
                this.panel = this.panel == 'function' ? false : 'function';
            },
            closePanel: function () {
                this.panel = false;
            },
            selectEmotion: function (event) {
                this.message += event.target.title;
            },
            scrollBottom: function (force) {
                this.$nextTick(function () {
                    // 如果滚动条不是拉到最底下则不滚动
                    if (force || $(".pop__chat-content").height() - ($('.pop__chat-body').scrollTop() + $('.pop__chat-body').height()) < 200) {
                        $(".pop__chat-body").scrollTop($(".pop__chat-content").height() + 1000);
                        setTimeout(function () {
                            $(".pop__chat-body").scrollTop($(".pop__chat-content").height() + 1000);
                        }, 200);
                    }
                });
            },
            uploadImage: function (event) {
                this.panel = false;
                var formData = new FormData();
                var file_input = event.target;
                formData.append('file', file_input.files[0]);
                im.ajax({
                    url: im.data.api.uploadImage,
                    type: 'POST',
                    data: formData,
                    //这两个设置项必填
                    contentType: false,
                    processData: false,
                    tip: 1,
                    success: function (res) {
                        if (res.code == 0) {
                            var content = '![图片](' + res.data.src + ')';
                            chat.doSend(content);
                        }
                    }
                });
                file_input.parentNode.reset();
            },
            uploadFile: function (event) {
                this.panel = false;
                var formData = new FormData();
                var file_input = event.target;
                formData.append('file', file_input.files[0]);
                im.ajax({
                    url: im.data.api.uploadFile,
                    type: 'POST',
                    data: formData,
                    //这两个设置项必填
                    contentType: false,
                    processData: false,
                    tip: 1,
                    success: function (res) {
                        if (res.code == 0) {
                            var content = 'file[' + res.data.name + "\t" + res.data.size + '](' + res.data.src + ')';
                            chat.doSend(content);
                        }
                    }
                });
                file_input.parentNode.reset();
            },
            dragUpload: function (files) {
                if (im.data.module != 'chat' || !this.id) {
                    this.$refs.upload.clear();
                    return;
                }
                if (files.length == 0) return;
                var file = files[0];
                var formData = new FormData();
                formData.append('file', file.file);
                this.$refs.upload.clear();
                var is_pic = /\.(gif|jpg|jpeg|png|webp)$/i.test(file.name);
                im.ajax({
                    url: is_pic ? im.data.api.uploadImage : im.data.api.uploadFile,
                    type: 'POST',
                    data: formData,
                    //这两个设置项必填
                    contentType: false,
                    processData: false,
                    tip: 1,
                    success: function (res) {
                        if (res.code == 0) {
                            var content = is_pic ? '![图片](' + res.data.src + ')' : 'file[' + res.data.name + "\t" + res.data.size + '](' + res.data.src + ')';
                            chat.doSend(content);
                        }
                    }
                });
            },
            beginVoiceReocord: function (event) {
                if (this.voiceRecording) {
                    return;
                }
                this.voiceRecording = true;

                // 兼容旧的浏览器
                if (navigator.mediaDevices === undefined) {
                    navigator.mediaDevices = {};
                }
                if (navigator.mediaDevices.getUserMedia === undefined) {
                    navigator.mediaDevices.getUserMedia = function (constraints) {
                        var getUserMedia = navigator.webkitGetUserMedia || navigator.mozGetUserMedia;
                        if (!getUserMedia) {
                            var e = new Error();
                            e.name = this.$lang('当前环境不支持语音');
                            return Promise.reject(e);
                        }
                        return new Promise(function (resolve, reject) {
                            getUserMedia.call(navigator, constraints, resolve, reject);
                        });
                    }
                }

                //创建音频
                try {
                    window.AudioContext = window.AudioContext || window.webkitAudioContext;
                    this.audio_context = new AudioContext;
                } catch (e) {
                    actionsheet.msg(e);
                    chat.voiceRecording = false;
                    return;
                }
                navigator.mediaDevices.getUserMedia({ audio: true }).then(function (stream) {
                    var input = chat.audio_context.createMediaStreamSource(stream);
                    chat.recorder = new Recorder(input);
                    chat.recorder.record();
                }).catch(function (e) {
                    chat.voiceRecording = false;
                    chat.showUserMediaError(e);
                });
            },
            showUserMediaError: function (e) {
                var error = e.name;
                switch (error) {
                    case 'NotAllowedError':
                    case 'PermissionDeniedError':
                        //error = '用户已禁止网页调用录音设备';
                        break;
                    // 没接入录音设备
                    case 'NotFoundError':
                    case 'DevicesNotFoundError':
                        //error = '录音设备未找到';
                        break;
                    // 其它错误
                    case 'NotSupportedError':
                        //error = '不支持录音功能';
                        break;
                }
                actionsheet.msg(error);
            },
            sendVoice: function (event) {
                if (!this.recorder || !this.voiceRecording) {
                    return;
                }
                this.voiceRecording = false;
                this.voiceTips = '';
                this.recorder.stop();
                this.recorder.exportWAV(function (blob) {
                    var wavBlob = blob;
                    var formData = new FormData();
                    var wavName = encodeURIComponent('voice_recording_' + new Date().getTime() + '.wav');
                    formData.append('file', wavBlob, wavName);
                    im.ajax({
                        url: im.data.api.uploadFile,
                        type: 'POST',
                        data: formData,
                        //这两个设置项必填
                        contentType: false,
                        processData: false,
                        tip: 1,
                        success: function (res) {
                            if (res.code == 0) {
                                var content = 'voice(' + res.data.src + ')';
                                chat.doSend(content);
                            }
                        }
                    });
                    chat.recorder.clear();
                    chat.audio_context.close();
                });
            },
            cancelVoice: function () {
                this.voiceRecording = false;
                if (this.recorder) {
                    this.recorder.stop();
                    this.recorder.clear();
                    this.audio_context.close();
                }
            },
            getmessage: function (scrollBottom, fn, reset) {
                if (this.messageLock || this.messageEnd || !this.id) {
                    return;
                }
                var data = { id: this.id, type: this.type };
                // 请求20条消息
                var limit = 20;
                data.limit = limit;
                if (!reset && this.mid) {
                    data.mid = this.mid;
                }
                var that = this;
                this.messageLock = true;
                // 获得最近20条消息
                im.ajax({
                    url: im.data.api.messageGet,
                    type: 'get',
                    data: data,
                    success: function (res) {
                        if (res.code == 0) {
                            if (!res.data.length || res.data.length < limit) {
                                that.messageEnd = true;
                            }
                            if (!chat.im.chatting[that.type + that.id]) {
                                im.syncChatting(that.type, that.id);
                            }
                            if (!reset) {
                                $.each(chat.im.chatting[that.type + that.id]['items'], function (k, v) {
                                    res.data.push(v);
                                });
                            }
                            chat.im.chatting[that.type + that.id].items = res.data;

                            // 修正scrollTop
                            if (fn) {
                                that.$nextTick(fn);
                            }
                            chat.scrollBottom(scrollBottom || false);
                            setTimeout(function () {
                                that.messageLock = false;
                                that.lastInsertTime = that.lastTime = 0;
                            }, 100);
                        }
                    },
                    error: function () {
                        that.messageLock = false;
                    }
                });
            },
            chat: function (type, id) {
                this.im.chat(type, id);
                this.userDetail.display = false;
                this.groupDetail.display = false;
            },
            applyFriend: function (uid) {
                im.setting('添加好友', '你需要发送好友请求，对方通过后才能成为好友', this.$lang('我是') + im.data.mine.nickname, '发送', function () {
                    im.ajax({
                        url: im.data.api.friendApply,
                        type: 'post',
                        data: { friend_uid: uid, postscript: setting.content },
                        success: function (res) {
                            if (res.code == 0) {
                                setting.display = false;
                            }
                        }
                    });
                });
            },
            deleteFriend: function (uid) {
                actionsheet.warningConfirm('删除好友', '确认删除？', function () {
                    im.ajax({
                        url: im.data.api.friendDelete,
                        type: 'post',
                        data: { friend_uid: uid },
                        success: function (res) {
                            if (res.code == 0) {
                                im.deleteFriend(uid);
                                actionsheet.display = false;
                                chat.userDetail.display = false;
                            }
                        }
                    });
                });
            },
            detail: function () {
                if (this.type == 'friend') {
                    this.im.userDetail(this.id);
                } else {
                    this.im.groupDetail(this.id);
                }
            },
            leaveGroup: function (gid) {
                actionsheet.warningConfirm('退出群组', '确认要退出群组么？', function () {
                    im.ajax({
                        url: im.data.api.groupLeave,
                        type: 'post',
                        data: { gid: gid },
                        success: function (res) {
                            if (res.code == 0) {
                                im.deleteGroup(gid);
                                chat.groupDetail.display = false;
                            }
                        }
                    });
                    actionsheet.display = false;
                });
            },
            deleteGroup: function (gid) {
                actionsheet.warningConfirm('解散群组', '确认要解散群组么？', function () {
                    im.ajax({
                        url: im.data.api.groupDelete,
                        type: 'post',
                        data: { gid: gid },
                        success: function (res) {
                            if (res.code == 0) {
                                im.deleteGroup(gid);
                                chat.groupDetail.display = false;
                            }
                        }
                    });
                    actionsheet.display = false;
                });
            },
            groupAddMember: function (gid) {
                group.memberAdd(gid);
            },
            groupDelMember: function (gid) {
                group.memberDel(gid);
            },
            groupMembers: function () {
                var that = this.groupDetail;
                if (that.ended) {
                    return;
                }
                var limit = 32;
                im.ajax({
                    url: im.data.api.groupMembers,
                    type: 'get',
                    data: { gid: this.groupDetail.gid, index: this.groupDetail.index, limit: limit },
                    success: function (res) {
                        if (res.code != 0) {
                            return;
                        }
                        var data = Object.values(res.data);
                        if (data.length < limit) {
                            that.ended = true;
                        }
                        $.each(data, function (key, item) {
                            if (that.index < item.index) {
                                that.index = item.index;
                            }
                            var nosame = true;
                            $.each(that.members, function (key2, item2) {
                                if (item2.uid == item.uid) {
                                    nosame = false;
                                }
                            });
                            nosame && that.members.push(item);
                        });
                    }
                });
            },
            memberDetail: function (uid) {
                if (this.im.setting.member_detail == 'off' && !this.isGroupOwner) {
                    return;
                }
                this.im.userDetail(uid);
            },
            toggleForbidSpeaking: function () {
                this.groupDetail.forbid_speaking = this.groupDetail.forbid_speaking == 1 ? 0 : 1;
                var gid = this.groupDetail.gid;
                var forbid_speaking = this.groupDetail.forbid_speaking;
                im.ajax({
                    url: im.data.api.groupForbiddenAll,
                    type: 'post',
                    data: { gid: gid, value: forbid_speaking },
                    success: function (res) { }
                });
            },
            syncUser: function (uid) {
                var that = this;
                return function (content, res) {
                    im.syncUser(uid);
                    if (chat.groupDetail.display) {
                        that.im.groupDetail(chat.groupDetail.gid);
                    }
                }
            },
            syncGroup: function (gid) {
                return function (content, res) {
                    im.syncGroup(gid);
                }
            },
            applyAgree: function (nid) {
                address_list.applyAgree(nid);
            },
            applyRefuse: function (nid) {
                address_list.applyRefuse(nid);
            },
            showtapMenu: function (event, type, to, mid, from, content) {
                this.supportRevoke = true;
                this.supportMemberDelete = this.supportForbidden = false;
                if (from != im.data.mine.uid) {
                    if (type == 'group') {
                        var group_info = im.getGroupFromLocal(to);
                        if (!group_info || group_info.uid != im.data.mine.uid) {
                            this.supportRevoke = false;
                        } else {
                            this.supportMemberDelete = this.supportForbidden = true;
                        }
                    } else {
                        this.supportRevoke = false;
                    }
                }
                this.tapMenuShow = true;
                this.$refs.menu.style.left = event.clientX + 5 + 'px';
                this.$refs.menu.style.top = event.clientY + 'px';
                this.$refs.menu.type = type;
                this.$refs.menu.id = to;
                this.$refs.menu.from = from;
                this.$refs.menu.mid = this.tapedMid = mid;
                this.$refs.menu.content = content;
            },
            copy: function () {
                var text = this.$refs.menu.content;

                function selectElementText(element) {
                    if (document.selection) {
                        var range = document.body.createTextRange();
                        range.moveToElementText(element);
                        range.select();
                    } else if (window.getSelection) {
                        var range = document.createRange();
                        range.selectNode(element);
                        window.getSelection().removeAllRanges();
                        window.getSelection().addRange(range);
                    }
                }

                var element = document.createElement('DIV');
                element.textContent = text;
                document.body.appendChild(element);
                selectElementText(element);
                document.execCommand('copy');
                element.remove();
            },
            revoke: function () {
                if (this.$refs.menu.mid) {
                    im.ajax({
                        url: im.data.api.messageRevoke,
                        type: 'post',
                        data: { type: this.$refs.menu.type, id: this.$refs.menu.id, mid: this.$refs.menu.mid },
                        success: function () {

                        }
                    });
                }
            },
            doGroupMemberDelete: function () {
                var gid = this.id;
                var uid = chat.$refs.menu.from;
                im.ajax({
                    url: im.data.api.groupMemberDelete,
                    type: 'post',
                    data: { members: [uid], gid: gid },
                    success: function (res) {
                    }
                });
            },
            showSubMemberForbiddenMenu: function () {
                if ($(this.$refs.subMemberForbiddenMenu).css('display') != 'block') {
                    $(this.$refs.subMemberForbiddenMenu).css('display', 'block');
                }
            },
            closeSubMemberForbiddenMenu: function () {
                $(this.$refs.subMemberForbiddenMenu).css('display', 'none');
            },
            doMemberForbidden: function (time) {
                var gid = this.id;
                var uid = chat.$refs.menu.from;
                im.ajax({
                    url: im.data.api.groupForbiddenUser,
                    type: 'post',
                    data: { uid: uid, gid: gid, time: time },
                    success: function (res) {

                    }
                });
            },
            closeTapMenu: function (delay) {
                this.$refs.menu.mid = this.$refs.menu.type = this.$refs.menu.mid = this.tapedMid = this.$refs.menu.content = this.$refs.menu.from = '';
                $(this.$refs.subMemberForbiddenMenu).css('display', 'none');
                if (!delay) {
                    chat.tapMenuShow = false;
                    return;
                }
                setTimeout(function () {
                    chat.tapMenuShow = false;
                }, delay);
            },
            handleScroll: function (evt) {
                var othis = $(evt.target), top = othis.scrollTop();
                var scrollHeight = othis.prop('scrollHeight');
                var updatescrollTop = function () {
                    var scrollHeightNow = othis.prop('scrollHeight');
                    var distance = scrollHeightNow - scrollHeight;
                    distance > 0 && othis.scrollTop(distance);
                };

                if (top <= 0) {
                    this.getmessage(false, updatescrollTop);
                }
                this.tapMenuShow = false;
            }
        }
    });

    // 搜索模块
    var search = new Vue({
        el: "#search",
        data: {
            im: im.data,
            searchText: '',
            resultItems: []
        },
        methods: {
            searchLocal: function () {
                this.resultItems = [];
                if (!this.searchText) {
                    return;
                }
                var that = this;
                //  本地找好友
                $.each(this.im.friend, function (char, items) {
                    $.each(items, function (key, item) {
                        item.type = 'friend';
                        item.id = item.uid;
                        if (item.nickname && item.nickname.indexOf(that.searchText) != -1) {
                            that.resultItems.push(item);
                            return;
                        }
                        if (item.name && item.name.indexOf(that.searchText) != -1) {
                            that.resultItems.push(item);
                            return;
                        }
                        if (item.remark && item.remark.indexOf(that.searchText) != -1) {
                            that.resultItems.push(item);
                            return;
                        }
                    });
                });
                // 本地找群组
                $.each(this.im.group, function (char, item) {
                    item.type = 'group';
                    item.id = item.gid;
                    if (item.groupname && item.groupname.indexOf(that.searchText) != -1) {
                        that.resultItems.push(item);
                        return;
                    }
                    if (item.name && item.name.indexOf(that.searchText) != -1) {
                        that.resultItems.push(item);
                        return;
                    }
                    if (item.remark && item.remark.indexOf(that.searchText) != -1) {
                        that.resultItems.push(item);
                        return;
                    }
                });
            },
            check: function () {
                if (this.searchText == '') {
                    this.im.module = 'chat';
                }
            },
            search: function () {
                var that = this;
                im.ajax({
                    url: im.data.api.getUserByName,
                    type: 'get',
                    msg: false,
                    data: { username: this.searchText },
                    success: function (res) {
                        if (res.code == 0 && typeof res.data.uid != 'undefined') {
                            that.im.userDetail(res.data.uid, 0, 1);
                        } else {
                            actionsheet.msg(that.$lang('未找到该用户'));
                        }
                    }
                });
                this.searchText == '';
            }
        }
    });

    // 用户详情浮层
    var user_detail = new Vue({
        el: '#user_detail',
        data: {
            im: im.data,
            remarkname: '',
            username: '',
            nickname: '',
            sign: '',
            avatar: '',
            isFriend: true,
            uid: 0,
            accountState: 'normal',
            display: false
        },
        methods: {
            deleteFriend: function () {
                chat.deleteFriend(this.uid);
            },
            applyFriend: function () {
                chat.applyFriend(this.uid);
            },
            updateNickname: function (content, res) {
                im.data.mine.nickname = im.htmlEncode(content);
            },
            uploadAvatar: function (event) {
                var formData = new FormData();
                var file_input = event.target;
                formData.append('file', file_input.files[0]);
                im.ajax({
                    url: im.data.api.uploadAvatar,
                    type: 'POST',
                    data: formData,
                    //这两个设置项必填
                    contentType: false,
                    processData: false,
                    tip: 1,
                    success: function (res) {
                        if (res.code == 0) {
                            var src = res.data.src;
                            im.ajax({
                                url: im.data.api.userUpdate,
                                type: 'post',
                                data: {
                                    avatar: src
                                },
                                success: function (res) {
                                    im.data.mine.avatar = src;
                                }
                            });
                        }
                    }
                });
                file_input.parentNode.reset();
            }
        }
    });

    // 群成员添加/删除
    var group = new Vue({
        el: "#group",
        data: {
            im: im.data,
            gid: 0,
            type: 'add',
            members: [],
            selectedItems: [],
            display: false
        },
        methods: {
            action: function () {
                if (this.type == 'create') {
                    im.ajax({
                        url: im.data.api.groupCreate,
                        type: 'post',
                        data: { members: this.selectedItems },
                        success: function (res) {
                            if (res.code == 0) {
                                var gid = res.data.gid;
                                im.addChatting({
                                    id: gid,
                                    name: res.data.groupname,
                                    avatar: res.data.avatar,
                                    type: 'group',
                                    unread_count: 0,
                                    items: []
                                });
                                im.syncGroup(gid);
                                im.listenGroup(res.data.gid);
                                im.data.chat('group', res.data.gid);
                            }
                        }
                    });
                    this.$refs.form.reset();
                    this.selectedItems = [];
                    this.display = false;
                    return;
                }
                var gid = this.gid;
                im.ajax({
                    url: this.type == 'add' ? im.data.api.groupMemberAdd : im.data.api.groupMemberDelete,
                    type: 'post',
                    data: { members: this.selectedItems, gid: gid },
                    success: function (res) {
                        im.data.groupDetail(gid);
                    }
                });

                this.$refs.form.reset();
                this.selectedItems = [];
                this.display = false;
            },
            create: function () {
                this.type = 'create';
                this.gid = 0;
                this.members = im.data.friend;
                this.display = true;
            },
            memberAdd: function (gid) {
                this.type = 'add';
                this.gid = gid;
                im.ajax({
                    url: im.data.api.groupMembers,
                    type: 'get',
                    data: { gid: gid },
                    success: function (res) {
                        if (res.code == 0) {
                            var members = res.data;
                            var diff = {};
                            $.each(im.data.friend, function (char, items) {
                                var tmp = [];
                                $.each(items, function (k, item) {
                                    var uid = item['uid'];
                                    if (!members[uid]) {
                                        tmp.push(item);
                                    }
                                });
                                if (tmp.length) {
                                    diff[char] = tmp;
                                }
                            });
                            group.members = diff;
                        }
                    }
                });
                this.display = true;
            },
            memberDel: function (gid) {
                this.type = 'del';
                this.gid = gid;
                im.ajax({
                    url: im.data.api.groupMembers,
                    type: 'get',
                    data: { gid: gid, pinyin: true, exclude: im.data.mine.uid },
                    success: function (res) {
                        if (res.code == 0) {
                            group.members = res.data;
                        }
                    }
                });
                this.display = true;
            },
            scrollIntoView: im.scrollIntoView
        }
    });


    // 语言切换
    var language = new Vue({
        el: "#language",
        data: {
            im: im.data,
            selectedValue: '',
            display: false
        },
        methods: {
            show: function () {
                this.selectedValue = im.data.language;
                this.display = true;
            },
            action: function () {
                if (!this.selectedValue) {
                    return;
                }
                localStorage.setItem('language', this.selectedValue);
                im.data.language = this.selectedValue;
                this.display = false;
            }
        }
    });

    var actionsheet = new Vue({
        el: '#actionsheet',
        data: {
            title: '',
            content: '', // 提示内容
            warning: false, // 危险提示
            callback: null, // 回调
            display: false
        },
        methods: {
            confirm: function (title, content, callback) {
                this.title = this.$lang(title);
                this.warning = false;
                this.content = this.$lang(content);
                this.callback = callback;
                this.display = true;
            },
            warningConfirm: function (title, content, callback) {
                this.title = this.$lang(title);
                this.warning = true;
                this.content = this.$lang(content);
                this.callback = callback;
                this.display = true;
            },
            msg: function (content) {
                this.title = this.$lang('提示');
                this.warning = false;
                this.content = this.$lang(content);
                this.callback = null;
                this.display = true;
            },
            cancel: function () {
                this.display = false;
            },
            action: function () {
                this.display = false;
                if (!this.callback) {
                    return;
                }
                this.callback.call(this);
            }
        }
    });

    // 备注等设置页面
    var setting = new Vue({
        el: '#setting',
        data: {
            im: im.data,
            title: '设置', // 设置标题
            desc: '', // 描述
            content: '', // 设置内容
            btn_name: '确定', // 按钮名称
            callback: null, // 回调
            display: false
        },
        methods: {
            cancel: function () {
                this.display = false;
            },
            action: function () {
                this.callback.call(this);
            }
        }
    });

    // 操作提示
    var toast = new Vue({
        el: '#toast',
        data: {
            dataPosting: false
        }
    });


    // 消息组件
    Vue.component('chat-message', {
        props: ['from', 'name', 'content', 'time', 'avatar', 'mid', 'im', 'sub_type'],
        data: function () {
            return { 'src': '', state: 'paused', duration: 0, htmlContent: '' };
        },
        computed: {
            messageType: function () {
                content = this.content.replace(/\n/g, '<br>').replace(/ /g, '&nbsp;').replace(/\[表情(\d+)\]/g, '<img class="pop__chat-msg-face" src="/static/web/img/emotion/face01/$1.png" title="[表情$1]"/>');
                content = content.replace(/\{POPBASEURI\}/g, im.data.baseUri);
                this.htmlContent = content;
                var url, info, message_type = 'pop__chat-msg-text';
                // 语音消息
                if (/^voice\(([^\)]+?)\)$/.exec(this.content) || /^voice\[\d+?\]\(([^\)]+?)\)$/.exec(this.content)) {
                    this.src = RegExp.$1;
                    return 'pop__chat-msg-voice';
                } else if (info = /\!\[.*?\]\(([^\)]+?)\)/.exec(content)) {
                    url = info[1];
                    if (im.isDangerousUrl(url)) {
                        return message_type;
                    }
                    message_type = 'pop__chat-msg-picture';
                    content = '<img src="' + url + '" />';
                } else if (info = /^file\[(.*?)[\t|\|](.*?)]\((.+?)\)$/.exec(content)) {
                    // 文件 file[文件名\tescape](文件下载地址)
                    var file_name = info[1];
                    var file_info = info[2];
                    url = info[3];
                    if (im.isDangerousUrl(url)) {
                        return message_type;
                    }

                    message_type = 'pop__chat-msg-file';
                    var index = file_name.lastIndexOf(".");
                    var ext = index ? file_name.substring(index + 1, file_name.length).toUpperCase() : "file";
                    ext = ext.length > 3 ? ext.substring(0, 4).toLowerCase() : ext;
                    if (ext == 'MP4' || ext == 'MOV' || ext == '3GP') {
                        message_type = 'pop__chat-msg-video';
                        content = '<video src="' + url + '"></video>';
                    } else {
                        content = '<div class="pop__chat-msg-file-cover">\
                         <i class="pop__chat-msg-icon">' + ext + '</i>\
                      </div>\
                      <div class="pop__chat-msg-file-info">\
                          <span class="pop__chat-msg-file-name"><a href="' + url + '" download="' + file_name + '">' + file_name + '</a></span>\
                          <span class="pop__chat-msg-file-size">' + file_info + '</span>\
                      </div>';
                    }
                } else if (/\[.*?\]\(([^\)]+?)\)/.test(content)) {
                    // 替换a连接，为了避免javascript注入，必须以http或者/开头，否则认为是无效连接
                    content = content.replace(/\[(.*?)\]\(((?=http|\/\/)[^\)]+?)\)/g, '<a href="$2" target="_blank">$1</a>');
                    content = content.replace(/\[(.*?)\]\((\/[^\)]+?)\)/g, '<a href="$2">$1</a>');
                } else if (/((([A-Za-z]{3,9}:(?:\/\/)?)(?:[\-;:&=\+\$,\w]+@)?[A-Za-z0-9\.\-]+|(?:www\.|[\-;:&=\+\$,\w]+@)[A-Za-z0-9\.\-]+)((?:\/[\+~%\/\.\w\-_]*)?\??(?:[\-\+=&;%@\.\w_]*)#?(?:[\.\!\/\\\w]*))?)/.test(content)) {
                    content = content.replace('&nbsp;', ' ').replace(/((([A-Za-z]{3,9}:(?:\/\/)?)(?:[\-;:&=\+\$,\w]+@)?[A-Za-z0-9\.\-]+|(?:www\.|[\-;:&=\+\$,\w]+@)[A-Za-z0-9\.\-]+)((?:\/[\+~%\/\.\w\-_]*)?\??(?:[\-\+=&;%@\.\w_]*)#?(?:[\.\!\/\\\w]*))?)/ig, function (item) {
                        return "<a href='" + item + "' target='_blank'>" + item + "</a>";
                    });

                    content = content.replace('  ', '&nbsp;&nbsp;');
                }
                content = content.replace(/@\[(.+?)\]\((\d+)\)/g, '<em>@$1</em>');
                this.htmlContent = content;
                return message_type;
            },
            type: function () {
                return chat.type;
            },
            to: function () {
                return chat.id;
            },
            isGroupOwner: function () {
                if (this.type != 'group') return false;
                var group_info = im.getGroupFromLocal(this.to);
                return group_info && group_info.uid == im.data.mine.uid
            },
            taped: function () {
                return chat.tapedMid == this.mid && chat.tapMenuShow ? 'taped' : '';
            }
        },
        methods: {
            play: function () {
                if (this.messageType != 'pop__chat-msg-voice') {
                    return;
                }
                $.each($('audio'), function (k, item) {
                    !item.paused && item.pause();
                });
                var voice = this.$refs.voice;
                if (voice.paused) {
                    voice.currentTime = 0;
                    voice.play();
                }
            },
            setState: function (e) {
                this.state = e.type == 'play' ? 'running' : 'paused';
            },
            durationChange: function () {
                var voice = this.$refs.voice;
                if (voice) {
                    this.duration = Math.ceil(voice.duration);
                }
            },
            noticeContent: function (content) {
                return im.stripTags(this.htmlContent);
            },
            userDetail: function () {
                if (this.type == 'group' && im.data.setting.member_detail == 'off' && !this.isGroupOwner) {
                    return;
                }
                var gid = 0;
                if (this.type == 'group' && this.im.mine.uid != this.from) {
                    var group_info = im.getGroupFromLocal(this.to);
                    if (this.isGroupOwner) {
                        gid = this.to;
                    }
                }
                return this.im.userDetail(this.from, gid);
            },
            showtapMenu: function (event, type, to, mid, from, content) {
                chat.showtapMenu(event, type, to, mid, from, content);
                return false;
            }
        },
        template: '<li v-if="sub_type!=\'notice\'" :class="{\'pop__chat-msg-me\':im.mine.uid==from, \'pop__chat-msg-others\':im.mine.uid!=from}" :key="mid">\
                      <a v-if="im.mine.uid!=from" class="pop__chat-msg-avatar" @click="userDetail"><img :src="avatar" /></a>\
                      <div class="pop__chat-msg-content">\
                        <p class="pop__chat-msg-author" v-if="this.type==\'group\'" v-html="name"></p>\
                        <div class="pop__chat-msg-msg" :class="[this.messageType, this.taped]" @click="play" @contextmenu.stop.prevent="showtapMenu($event,type,to, mid, from, content)">\
                            <span v-if="this.messageType!=\'pop__chat-msg-voice\'" v-html="htmlContent"></span>\
                            <span v-else-if="this.messageType==\'pop__chat-msg-voice\'">\
                                <template v-if="im.mine.uid == from">\
                                    <span class="pop__voice-box pop__float-right pop__route180" :class="{\'pop__voice-playing\':state==\'running\'}"></span>\
                                    <span class="pop__voice-body pop__float-left"><span v-if="duration!=0">{{duration}}"</span></span>\
                                </template>\
                                <template v-else>\
                                    <span class="pop__voice-body pop__float-right pop__text-right">{{duration}}"</span>\
                                    <span class="pop__voice-box pop__float-left" :style="{\'animation-play-state\':state}" :class="{\'pop__voice-playing\':state==\'running\'}"></span>\
                                </template>\
                                <audio preload="auto" hidden="true" ref="voice" @play="setState" @ended="setState" @pause="setState" @abort="setState" @error="setState" @stalled="setState" @empted="setState" @durationchange="durationChange"><source :src="src" type="audio/mpeg"></audio>\
                            </span>\
                        </div>\
                      </div>\
                      <a v-if="im.mine.uid==from" class="pop__chat-msg-avatar" @click="userDetail" :class="this.taped" @contextmenu.stop.prevent="showtapMenu($event,type,to, mid, from, content)"><img :src="avatar" /></a>\
                  </li>\
                  <li v-else-if="sub_type==\'notice\' && this.messageType" class="pop__chat-msg-notice"><span v-html="noticeContent(content)"></span></li>'
    });


    $(document).click(function (e) {
        if ($('.pop__emotion-wrapper').has(e.target).length == 0) {
            chat.panel = false;
        }
        chatting.contextmenuId = 0;
        chat.closeTapMenu();
        left_bar.subMenuDisplay = false;
    });

    $(document).click(function (e) {
        if (Date.parse(new Date()) - chat.userDetail.display || 0 > 10) {
            chat.userDetail.display = false;
        }
        if (Date.parse(new Date()) - chat.groupDetail.display || 0 > 10) {
            chat.groupDetail.display = false;
        }
        if (Date.parse(new Date()) - chat.applyDetail.display || 0 > 10) {
            chat.applyDetail.display = false;
        }
        if (Date.parse(new Date()) - user_detail.display || 0 > 10) {
            user_detail.display = false;
        }
    });

    // 页面关闭时
    $(window).on('beforeunload', function () {
        chat.reset(chat.id, chat.type);
    });

    setInterval(function () {
        im.autoUpdateTime();
    }, 60000);

    /* 图片预览 */
    $(function () {
        var curIndex = 0, img_view_swiper;
        $(".pop__chat-content").on("click", ".pop__chat-msg-picture", function () {
            $(this).find('img').css('max-height', window.innerHeight + 'px');
            var html = '<div class="swiper-slide"><div class="swiper-zoom-container">' + $(this).html() + '</div></div>';

            $(".pop__img-view-container .swiper-wrapper").html(html);
            $(".pop__img-view").show();

            img_view_swiper = new Swiper('.pop__img-view-container', {
                pagination: false,
                paginationClickable: true,
                zoom: true,
                observer: true,
                observeParents: true,
                initialSlide: 0
            });
        });
        // 关闭预览
        $(".pop__img-view").on("click", function (e) {
            var that = $(this);
            img_view_swiper.destroy(true, true);
            $(".pop__img-view-container .swiper-wrapper").html('');
            that.hide();
        });
    });

    // 视频
    $(function () {
        var video = document.getElementById('pop__video');
        $(".pop__chat-content").on("click", ".pop__chat-msg-video", function () {
            video.src = $(this).find("video").attr("src");
            $(".pop__video-view").show();
            if (video.paused) {
                video.play();
            } else {
                video.pause();
            }
        });
        video.addEventListener("ended", function () {
            video.currentTime = 0;
        }, false);

        $(video).on('click', function (e) {
            e.stopPropagation();
        });

        // 关闭预览
        $(".pop__video-view").on("click", function () {
            $(".pop__video-view").hide();
            video.currentTime = 0;
            video.pause();
        });

        // 进入全屏、退出全屏
        video.addEventListener("x5videoenterfullscreen", function () {
            console.log("进入全屏");
        }, false);
        video.addEventListener("x5videoexitfullscreen", function () {
            $(".pop__video-view .pop__close-btn").trigger("click");
        }, false);
    });

});